'_NUMLOCK ON
'handle& = _NEWIMAGE(100, 45, 0)
'SCREEN handle&
CLEAR
WIDTH 80, 25: VIEW PRINT 1 TO 25
$VERSIONINFO:CompanyName=George A. Lee - BioRhythm
$VERSIONINFO:FILEVERSION#=4,3,0,0
$VERSIONINFO:ProductVersion=4.3.0.0
$VERSIONINFO:FileDescription=Chart your Biorhythms (NOT Starcharts)
$VERSIONINFO:ProductName=BioRhythm
$VERSIONINFO:LegalCopyright=1985-2020
$VERSIONINFO:Web=http://www.oiccs.com
_MOUSEHIDE
'_SCREENMOVE _MIDDLE
'BioRhythmMain            "biorhyth.exe"
'BioEdit                   "bioedit.exe"
'SetupBio                  "setupbio.exe"
'BioPrintModule            "ModulePrint.exe"
'BioGraph Screen           "biograph.exe"
'BioPrint                  "bioprint.exe"
'WIDTH 80, 43
$RESIZE:ON
$RESIZE:STRETCH
$RESIZE:SMOOTH
BioRhythmMain:
CLEAR
WIDTH 80, 25: VIEW PRINT 1 TO 25
'''OPEN "a", 1, "ScreenWidth.txt"
'''PRINT #1, _DESKTOPWIDTH, _DESKTOPHEIGHT
'''PRINT #1, _WIDTH, _HEIGHT
'''PRINT #1,

'''CLOSE 1

exitsignal% = _EXIT
'_ICON
i& = _LOADIMAGE("icons\bio.bmp", 32)
_ICON i&
'$EXEICON:'icons\bio.ico'
'_FREEIMAGE i&

_TITLE "BioRhythm"
'_FULLSCREEN
_ALLOWFULLSCREEN
'                                                                                                     * WIDTH 80, 25
CLEAR
CLS
ON ERROR GOTO BRERROR
' BioRhythm.Bas
ThisFile$ = "biorhyth.exe"
hm% = 1
KEY(1) ON
KEY(10) ON
ON KEY(1) GOSUB helpfiles:
ON KEY(10) GOSUB theory


'   *************************
'   *       BIORHYTHM       *
'   *    by: GEORGE A LEE   *
'   *         MS-DOS        *
'   * Microsoft's BASIC PDS *
'   *    DEC 26,1985-2020   *
'   *************************
ovl0$ = "biologo.bsv": ovl1$ = "biowho1.bsv": ovl2$ = "biowho2.bsv": ovl3$ = "biowho3.bsv": ovl4$ = "biowho4.bsv": ovl5$ = "biowho5.bsv": ovl6$ = "bioload.bsv"
C$ = "overlays\"
BR120: BLOAD C$ + ovl0$
LOCATE 22, 16: COLOR 15, 4: PRINT "[F1] Menu Explanations        [F10] BioRhythm Theory";
COLOR 15, 4
COLOR 7, 0
BR130: LOCATE 1, 1, 0: CH$ = INPUT$(1): LOCATE , , 1
IF CH$ = CHR$(27) THEN GOTO BR210
IF (CH$ < "1") + (CH$ > "6") THEN GOTO BR130
CH = VAL(CH$)
ON CH GOTO BR170, BR180, BR190, BR210, BR220, BR205, BR165
BR165: GOTO BR130
BR170: BLOAD C$ + ovl6$

GOTO bioprint
BR180: BLOAD C$ + ovl6$: GOTO biograph
SYSTEM
BR190: BLOAD C$ + ovl6$: GOTO BioEdit
END
BR205: GOTO setupbio
BR210: SYSTEM
BR220: LOCATE 1, 1, 0: BLOAD C$ + ovl1$
RT$ = INPUT$(1)
BLOAD C$ + ovl2$
RT$ = INPUT$(1)
BLOAD C$ + ovl3$
RT$ = INPUT$(1)
BLOAD C$ + ovl4$
RT$ = INPUT$(1)
BLOAD C$ + ovl5$
RT$ = INPUT$(1)
GOTO BR120
BRERROR: F% = FREEFILE
OPEN "error_reports\BioRhyth.err" FOR APPEND AS #F%
PRINT #F%, " Program Error "; ERR; "in line:"; ERL; "Error Line"; _ERRORLINE; "on "; DATE$; " at "; TIME$
CLOSE #F%
RESUME NEXT
'end ofBioRhythm Main Menu program lines

'Begin BioEdit Program Lines
'exitsignal% = _EXIT
BioEdit:
CLEAR
KEY(1) ON
hm% = 2
ON KEY(1) GOSUB helpfiles:


'_ICON
i& = _LOADIMAGE("icons\biorhythm.bmp", 32)
_ICON i&
_TITLE "BioRhythm Data Editor"
BEBegin: 'CLEAR
'   *************************
'   *      BioEdit.EXE      *
'   *    by: GEORGE A LEE   *
'   *         TRS-80        *
'   *     MODEL IV BASIC    *
'   *     (c)DEC 26,1985    *
'   *     (c)Apr 25,1987    *
'   *         MS-DOS        *
'   *    (c)Apr 20,1988     *
'   *   64 Bit computers    *
'   *  (c)Jun 16,1988-2020  *
'   *************************
'
CLOSE
F% = FREEFILE
OPEN "I", F%, "biopath.cfg"
LINE INPUT #F%, pat2$
LINE INPUT #F%, pat2$
CLOSE #F%
ON ERROR GOTO ErrorPrint
REDIM CR$(26), START(26), FINISH(26)
Pnt$ = CHR$(26)
CB = 9
FOR I = 1 TO 26
    CR$(I) = CHR$(64 + I)
    START(I) = CB + 1: FINISH(I) = CB + 100
    CB = CB + 100
NEXT I

Black = 0: Blue = 1: Green = 2: Cyan = 3: Red = 4: Magenta = 5: Brown = 6: Normal = 7: Gray = 8: LBlue = 9: LGreen = 10: LCyan = 11: LRed = 12: LMagenta = 13: Yellow = 14: White = 15
COLOR Normal, Black
'                                                                                            * VIEW PRINT 1 TO 25
CLS
linelenght$ = "                                                                                "
'LOCATE 2, 1: COLOR Cyan: PRINT "NAME TO SEARCH:                                                QUIT";: COLOR Normal: PRINT " to End";
nametosearchline = 1: nametosearchpos = 17
Message$ = "     *** M E N U ***     ": '"S E A R C H"
COLOR 14, 0
CALL BEcenterbar(Message$)
CALL BEmenu
GOSUB BEKeyIn
GOTO BEBegin
END
'                                     Search the Record
BESearchFile:
Message$ = "      S E A R C H     "
CALL BEcenterbar(Message$)
COLOR 7, 1: LOCATE 14, 1: FOR spaceit = 1 TO 12: PRINT STRING$(80, 32);: NEXT spaceit
LOCATE 2, 1: COLOR Cyan, Black: PRINT "NAME TO SEARCH:                                                QUIT";: COLOR Normal: PRINT " to End";
LOCATE 2, 17
LINE INPUT NameEntered$
IF UCASE$(NameEntered$) = "QUIT" THEN CLOSE: GOTO BEBegin
GOSUB BEcaseconvert
LOCATE 2, 17: PRINT NameEntered$

GOSUB BEopenfile

CALL waitforit

CLOSE: GOTO BEBegin

BEEditRecord: '-----------------------------------------------------------------------EDIT THE RECORD-----------------------------------
Message$ = "      E D I T O R      "
COLOR 10, 0
CALL BEcenterbar(Message$)

COLOR 7, 1: LOCATE 14, 1: FOR spaceit = 1 TO 12: PRINT STRING$(80, 32);: NEXT spaceit 'COLOR Yellow
LOCATE 2, 1: COLOR Cyan, Black: PRINT "RECORD # TO EDIT:                                          Enter ";: COLOR LBlue + 16: PRINT "0";: COLOR Normal: PRINT " to Exit";
LOCATE 2, 19
INPUT RecNum%
LOCATE 2, 25: PRINT SPC(54);
'PRINT RecNum%
IF RecNum% = 0 THEN CLOSE: GOTO BEBegin
'    Open file to read entries and assign field characters.

FF% = FREEFILE
OPEN "R", FF%, pat2$ + "BIO.DAT", 60: L1% = LOF(FF%) / 60
FIELD FF%, 30 AS Name1$, 10 AS Date1$, 10 AS Date2$, 6 AS Gender$, 1 AS Active$, 3 AS Nil$
IF RecNum% = 1 THEN RecNum% = 2
IF RecNum% >= L1% THEN LOCATE 2, 19: COLOR 15: PRINT "Out of Range.  Press ANY Key to continue.";: PRINT SPC(15): CALL waitforit: LOCATE 2, 19: COLOR 7, 1: PRINT STRING$(41, " ");: CLOSE #1: GOTO BEEditRecord
IF RecNum% < L1% THEN
    GET FF%, RecNum%: COLOR 7, 0
END IF
LOCATE 2, 19: COLOR 15
IF LEFT$(Name1$, 5) = "%%%%%" THEN
    LOCATE 2, 19: COLOR 15: PRINT " Record";: COLOR 14: PRINT RecNum%;: COLOR 15: PRINT "does NOT exist.";: PRINT SPC(34);: CALL waitforit: LOCATE 2, 19: COLOR 7, 1: PRINT STRING$(41, " ");: CLOSE #1: GOTO BEEditRecord
END IF

COLOR 7, 1
SE% = RecNum%
GOSUB BETopper
COLOR Normal, Black
TempRecord$ = "                              "
Message$ = "     E D I T O R      "
COLOR LGreen, Black
CALL BEcenterbar(Message$)
COLOR White, Blue: LOCATE 14, 1: PRINT USING "RECORD ####"; SE%;
BEeditname:
COLOR White + 16, Black: LOCATE 6, 9: PRINT Pnt$;: COLOR White, Blue
LOCATE 15, 2: PRINT "NAME:                                      (will be truncated to 30 characters)";
LOCATE 15, 9: LINE INPUT NameEntered$: IF NameEntered$ = "" THEN NameEntered$ = Name1$: skipit = 1
GOSUB BEcaseconvert
IF skipit = 0 THEN
    LOCATE 6, 10: PRINT SPC(30);
    LOCATE 6, 10: COLOR LCyan: PRINT NameEntered$;
END IF
LOCATE 15, 9: PRINT NameEntered$;


COLOR , Black: LOCATE 6, 9: PRINT " ";
'NL = LEN(NameEntered$)
'MID$(TempRecord$, 1, NL) = NameRecord$
LSET Name1$ = NameEntered$
BEeditbirth:
COLOR White + 16, Black: LOCATE 6, 40: PRINT Pnt$;: COLOR White, Blue
ckit = White
BEBDAgain:
cursorline = 17: cursorposition = 12: entry$ = ""
LOCATE 17, 2: PRINT "BIRTHDAY:               ";: COLOR ckit: PRINT "Using MM-DD-YYYY format";
Dater$ = entry$

CALL BEkeyboardentries(entry$, cursorline, cursorposition)


Birthday$ = entry$

IF Birthday$ = "" THEN Birthday$ = Date1$: skipit = 1
IF LEN(Birthday$) < 10 THEN BEEP: ckit = LRed + 16: GOTO BEBDAgain

IF skipit = 0 THEN
    LOCATE 6, 41: COLOR LCyan: PRINT Birthday$
END IF
LOCATE 17, 12: PRINT Birthday$;: LOCATE 17, 26: PRINT SPC(30);
skipit = 0


COLOR , Black: LOCATE 6, 40: PRINT " ";
LSET Date1$ = Birthday$

COLOR White + 16, Black: LOCATE 6, 55: PRINT Pnt$;: COLOR White, Blue
BEeditdatefiled:
LOCATE 19, 2: PRINT "DATE FILED:             ";: COLOR ckit: PRINT "Using MM-DD-YYYY format;"
cursorline = 19: cursorposition = 14: entry$ = ""
CALL BEkeyboardentries(entry$, cursorline, cursorposition)
DateFiled$ = entry$
IF DateFiled$ = "" THEN DateFiled$ = Date2$: skipit = 1
IF LEN(DateFiled$) < 10 THEN BEEP: ckit = LRed + 16: GOTO BEeditdatefiled

IF skipit = 0 THEN
    LOCATE 6, 56: COLOR LCyan: PRINT DateFiled$;
END IF
LOCATE 19, 14: PRINT DateFiled$;: LOCATE 19, 26: PRINT SPC(30);
skipit = 0

LSET Date2$ = DateFiled$

COLOR , Black: LOCATE 6, 55: PRINT " ";
COLOR White + 16, Black: LOCATE 6, 68: PRINT Pnt$;
BEeditgender:
LOCATE 6, 69: COLOR 7, 0: PRINT Gender$;
COLOR White, Blue
LOCATE 21, 2: PRINT "GENDER:";
LOCATE 21, 11: LINE INPUT NameEntered$: IF NameEntered$ = "" THEN NameEntered$ = Gender$: skipit = 1
GOSUB BEcaseconvert: gen$ = NameEntered$
IF UCASE$(LEFT$(gen$, 1)) = "F" THEN gen$ = "Female"
IF UCASE$(LEFT$(gen$, 1)) = "M" THEN gen$ = "Male  "
IF UCASE$(LEFT$(gen$, 1)) = "O" THEN gen$ = "Other"

IF skipit = 1 THEN LOCATE 6, 69: COLOR Normal, Black: PRINT gen$; ELSE COLOR LCyan, Blue: LOCATE 6, 69: PRINT gen$;

COLOR LCyan, Blue
LOCATE 21, 11: PRINT gen$;
skipit = 0

'COLOR LCyan, Blue: LOCATE 6, 69: PRINT gen$;
COLOR , Black: LOCATE 6, 68: PRINT " ";
'IF Gender$ = "%%%%%%" THEN gen$ = "      "
LSET Gender$ = gen$
BEeditactive:
COLOR White + 16, Black: LOCATE 6, 78: PRINT Pnt$;: COLOR White, Blue
LOCATE 23, 2: PRINT "ACTIVE or INACTIVE:          [A or I] (only means file active or file inactive)";

LOCATE 23, 23: LINE INPUT MakeActive$
IF MakeActive$ = "" THEN MakeActive$ = Active$: skipit = 1
MakeActive$ = UCASE$(MakeActive$)

IF skipit = 0 THEN
    LOCATE 6, 79: COLOR LCyan: PRINT MakeActive$;
END IF
LOCATE 23, 23: PRINT MakeActive$;
skipit = 0

COLOR , Black: LOCATE 6, 78: PRINT " ";
LSET Active$ = MakeActive$
LSET Nil$ = "###"
'LOCATE 6, 79: PRINT MakeActive$;
COLOR 10, 1: LOCATE 25, 2: PRINT "<S>ave or <A>bort edit ";

DO: YN$ = UCASE$(INKEY$)
    IF YN$ = "A" THEN CLOSE #1: EXIT DO:
    IF YN$ = "S" THEN PUT #FF%, RecNum%: BEEP: EXIT DO
LOOP
CLOSE #FF%: GOTO BEBegin
'                                                           END of EDIT ROUTINE 


BEKeyIn:
in$ = ""
DO: in$ = UCASE$(INKEY$)
    IF in$ = "S" THEN GOSUB BESearchFile: RETURN
    IF in$ = "P" THEN CALL BEPrintToFile: RETURN
    IF in$ = "I" THEN CALL BEInactive: RETURN
    IF in$ = "E" THEN GOSUB BEEditRecord: RETURN
    IF in$ = "R" THEN CALL BEdatefixer: RETURN
    IF in$ = CHR$(27) THEN
        CLOSE: GOTO BioRhythmMain
    END IF

LOOP
RETURN

BEopenfile:
'    Open file to read entries and assign field characters.

CLOSE 1: OPEN "R", 1, pat2$ + "BIO.DAT", 60: L1% = (LOF(1) / 60) - 1
FIELD 1, 30 AS Name1$, 10 AS Date1$, 10 AS Date2$, 6 AS Gender$, 1 AS Active$, 3 AS Nil$

FOR SE% = 2 TO L1%
    ReDo:
    GET 1, SE%
    IF LEFT$(Name1$, 2) = "%%" THEN SE% = SE% + 1: GOTO ReDo
    'IF SE% = L1% THEN LOCATE 8, 1: COLOR 12 + 16: PRINT "NOT IN FILE, TRY AGAIN!": NIF = 1: COLOR 7

    'IF LEFT$((UCASE$(Name1$)), LEN(NameEntered$)) = UCASE$(NameEntered$) THEN GOTO Gotcha: 'INSTR(1, UCASE$(Name1$), UCASE$(NameEntered$)) <> 0 THEN GOTO Gotcha
    IF INSTR(1, UCASE$(Name1$), UCASE$(NameEntered$)) <> 0 THEN GOTO BEGotcha
NEXT SE%
BEGotcha:
GOSUB BETopper
IF SE% >= L1% THEN LOCATE 6, 1: COLOR 12 + 16: PRINT "NOT IN FILE, TRY AGAIN!": LOCATE 8, 1: PRINT SPC(40);: NIF = 1: COLOR 15 + 16: LOCATE 19, 30: PRINT "Any Key to Continue";: COLOR 7: GOTO BEFinished
LOCATE 8, 1: PRINT "Is this the selection? ";: YN$ = UCASE$(INPUT$(1))
IF YN$ = "Y" THEN delrec% = SE%: GOTO BEQuery:
IF YN$ = "N" THEN SE% = SE% + 1: GOTO ReDo
BEFinished:
CLOSE 1: RETURN




BETopper:
COLOR Normal, Black
PRINT: LOCATE 4, 1: PRINT "RECORD"; TAB(10); "NAME"; TAB(41); "BIRTHDATE"; TAB(56); "DATE FILED"; TAB(69); "GENDER  ACTV";
PRINT STRING$(6, "-"); TAB(10); STRING$(9, "-"); TAB(41); STRING$(9, "-"); TAB(56); STRING$(10, "-"); TAB(69); STRING$(6, "-"); "  ----";
PRINT USING " ####    \                             \"; SE%; Name1$;
PRINT TAB(41); Date1$;
PRINT TAB(56); Date2$;
PRINT TAB(69); Gender$; "    "; Active$: PRINT
RETURN


BEQuery:
LOCATE 15, 26: COLOR 7, 1
PRINT "EDIT (<";
COLOR 10: PRINT "Y";
COLOR 7: PRINT ">es/<";
COLOR 10: PRINT "N";
COLOR 7: PRINT ">o/<";
COLOR 10: PRINT "D";
COLOR 7: PRINT ">elete";
PRINT ")";
COLOR 7: SOUND 1568, 1: 'BEEP

YN$ = UCASE$(INPUT$(1)): PRINT YN$;
'470 LOCATE 8, 1: PRINT SPC(45);: LOCATE 9, 1: PRINT SPC(46);
FOR MM = 1 TO 3: PRINT: NEXT MM
IF YN$ = "Y" THEN GOSUB BE1000: ' ELSE GOTO 280
IF YN$ = "N" THEN CLOSE: GOTO BEBegin
IF YN$ = "D" THEN GOSUB BEDeleter: '5000
'IF YN$ = "R" THEN GOSUB 5500
'goto BEBegin

'500 GOTO 280
RETURN
BEDeleter:
PCOPY 0, 1
WIDTH 40, 25
COLOR 13 + 16, 1
LOCATE 3, 9: PRINT "                       "
LOCATE 4, 9: PRINT "        WARNING        "
COLOR 12, 1
LOCATE 5, 9: PRINT "                       "
LOCATE 6, 9: PRINT "  THIS CHOICE CANNOT   "
LOCATE 7, 9: PRINT "  BE UNDONE            "
LOCATE 8, 9: PRINT "                       "
COLOR 14, 1
LOCATE 9, 9: PRINT "  ARE YOU SURE (Y/N)?  "
COLOR 12, 1
LOCATE 10, 9: PRINT "                       "
BETryItAgain:
YN$ = INPUT$(1)
IF UCASE$(YN$) = "N" THEN PCOPY 1, 0: RETURN BEBegin: '                                              * then width 80,25
IF UCASE$(YN$) = "Y" THEN GOTO BEDeleteIt: 'okay$ = ""
IF YN$ <> "Y" THEN GOTO BETryItAgain
BEDeleteIt:
WIDTH 80: '                                                                                                  *WIDTH 80, 25
'       DELETE RECORD
CLOSE 1: OPEN "R", 1, "BIO.DAT", 60
FIELD 1, 30 AS N1$, 10 AS Date1$, 10 AS Date2$, 6 AS ge$, 1 AS Active$, 3 AS Nil$
LSET N1$ = "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
LSET Date1$ = "%%%%%%%%%%"
LSET Date2$ = "%%%%%%%%%%"
LSET ge$ = "%%%%%%"
LSET Active$ = "%"
LSET Nil$ = "%%%"
PUT 1, delrec%
CLOSE #1

RETURN BEBegin: '10


BE1000: '     Input for edit function
Message$ = "E D I T O R"
CALL BEcenterbar(Message$)
'Pnt$ = "  " + CHR$(26)
LOCATE 14, 1: FOR spaceit = 1 TO 12: PRINT STRING$(80, 32);: NEXT spaceit
A = 6: B = 9: C = 30
'' LOCATE 15: PRINT STRING$(3, 32);: LOCATE 6, B + 1: PRINT STRING$(C, 32);: LOCATE 6, B + 1: RETURN
'1100 LOCATE 13, 1: PRINT STRING$(80, 205);
'LOCATE 14, 33: COLOR 13: PRINT "   E D I T   ";
'COLOR 7: PRINT STRING$(80, 205);
LOCATE 6, 9: COLOR 15 + 16
Changed = 0
' --------------------------------------------------------------------------------------- NAME ENTERED BLOCK
PRINT Pnt$;: COLOR 14: PRINT N1$;: COLOR 7: LOCATE 14, 40: PRINT "(case NOT important - will be converted)";
LOCATE 14, 1: LINE INPUT "NAME:  "; NE$
IF NE$ = "" THEN NE$ = Name1$: Changed = 0: ELSE Changed = 1
LOCATE 14, 40: PRINT SPC(40);: ': PRINT SPC(LEN(NE$));: '            PRINT STRING$(3, 32);: LOCATE 6, B + 1: PRINT STRING$(C, 32);: LOCATE 6, B + 1:

LOCATE 6, 9: PRINT " ";
NameEntered$ = NE$
GOSUB BEcaseconvert
NE$ = NameEntered$: NameEntered$ = ""
recordedname$ = NE$

IF Changed THEN clr = Yellow: Changed = 0: ELSE clr = 7
LOCATE 14, 1: PRINT SPC(30);
LOCATE 14, 1: PRINT "NAME: ";
spacer = LEN(recordname$)
COLOR clr: LOCATE 14, 7: PRINT recordedname$; SPC(30 - spacer);: '"NE$;
'LOCATE 6, 10: COLOR clr: PRINT recordedname$; SPC(30 - spacer);: COLOR 7
'LOCATE 14, 7: PRINT STRING$(50, 32);
EN$ = NE$
' --------------------------------------------------------------------------------------- DATE OF BIRTH BLOCK
LOCATE 6, 40: COLOR 15 + 16: PRINT Pnt$;: COLOR 7: PRINT Date1$;: COLOR 7
three% = 3: one% = 1: six% = 6
BEBirthItAgain:
LOCATE 16, 1: PRINT "D.O.B. ";: cursorline = 16: curposition = 8: entry$ = ""
CALL BEkeyboardentries(entry$, cursorline, curposition)
DA1$ = entry$: IF DA1$ = "" THEN DA1$ = Date1$: Changed = 0: ELSE Changed = 1

'PRINT entry$

IF LEN(DA1$) < 10 THEN LOCATE 16, 40: PRINT "Use this format: (mm-dd-year)";: BEEP: GOTO BEBirthItAgain
MID$(DA1$, three%, one%) = "-": MID$(DA1$, six%, one%) = "-"
IF Changed THEN clr = Yellow: Changed = 0: ELSE clr = 7
COLOR clr: LOCATE 6, 41: COLOR clr: PRINT DA1$;: LOCATE 16, 8: PRINT DA1$;
LOCATE 6, 40: PRINT " ";

' --------------------------------------------------------------------------------------- DATE FILED BLOCK
'IF (LEFT$(DA1$, 1) = "D") + (LEFT$(DA1$, 1) = "d") THEN DA1$ = EN$
A = 37: B = 40: C = 3
'LOCATE 15: PRINT STRING$(3, 32);: LOCATE 6, B + 1: PRINT STRING$(C, 32);: LOCATE 6, B + 1: ' 1020

LOCATE 18, 1: PRINT SPC(LEN(NE$));: PRINT Pnt$;: COLOR 14: PRINT N1$;: COLOR 7: PRINT DA1$


LOCATE 18, 1: PRINT STRING$(50, 32);
LOCATE 6, 55: COLOR 15 + 16: PRINT Pnt$;: COLOR 7: PRINT Date2$;

BEDateItAgain:
cursorline = 18: cursorposition = 13
LOCATE 18, 1: PRINT "DATE FILED: "; da2$: entry$ = ""
CALL BEkeyboardentries(entry$, cursorline, cursorposition)
da2$ = entry$:
IF da2$ = "" THEN
    Changed = 0
    da2$ = Date2$
ELSE Changed = 1: '                       LEFT$(Date2$, 6) + RIGHT$(Date2$, 4) ELSE da2$ = LEFT$(da2$, 6) + RIGHT$(da2$, 4): Changed = 1
END IF
IF LEN(da2$) < 10 THEN BEEP: LOCATE 18, 40: PRINT "Use this format: (mm-dd-year)";: GOTO BEDateItAgain

MID$(da2$, three%, one%) = "-": MID$(da2$, six%, one%) = "-"
LOCATE 6, 56: COLOR clr: PRINT da2$;
LOCATE 6, 55: PRINT " ";
LOCATE 18, 13: COLOR clr: PRINT da2$;


IF Changed THEN clr = Yellow: Changed = 0: ELSE clr = 7
LOCATE 15: A = 52: B = 55: C = 2: PRINT STRING$(3, 32);: LOCATE 6, B + 1: PRINT STRING$(C, 32);: LOCATE 6, B + 1: COLOR clr: PRINT da2$;
LOCATE 6, 54: PRINT " ";

'                                                                                         GENDER BLOCK
'LOCATE 17, 1: PRINT STRING$(50, 32);
LOCATE 6, 68: COLOR 15 + 16: PRINT Pnt$;: COLOR 14: PRINT ge$;: COLOR 7

LOCATE 20, 1: LINE INPUT "GENDER: (M/F/O): "; NE$
NE$ = UCASE$(NE$): IF NE$ = "" THEN NE$ = ge$: Changed = 1 ELSE Changed = 0
IF UCASE$(LEFT$(NE$, 1)) = "M" THEN NE$ = "Male  ": ' GOTO 1330
IF UCASE$(LEFT$(NE$, 1)) = "F" THEN NE$ = "Female": ' GOTO 1330
IF UCASE$(LEFT$(NE$, 1)) = "O" THEN NE$ = "Other "
NE$ = LEFT$(NE$, 6)
NameEntered$ = NE$
GOSUB BEcaseconvert
NE$ = NameEntered$: NameEntered$ = ""
Gender$ = NE$: LOCATE 6, 68: PRINT " ";
LOCATE 6, 69: COLOR clr: PRINT NE$;
LOCATE 20, 18: COLOR clr: PRINT NE$;
'LOCATE 17, 1: PRINT STRING$(50, 32);

'                                                                                         ACTIVE/INACTIVE BLOCK
LOCATE 6, 76: COLOR 15 + 16: PRINT Pnt$;: COLOR 14: PRINT TAB(79); Active$;: COLOR 7
LOCATE 22, 1: LINE INPUT "ACTIVE/INACTIVE? (A/I) "; Activate$: IF Activate$ = "" THEN Activate$ = Active$: Changed = 0 ELSE Changed = 1
NE$ = UCASE$(Activate$): Activate$ = NE$
LOCATE 6, 76: PRINT " ";
A = 75: B = 78: C = 3: ' GOSUB 1020
COLOR clr
LOCATE 22, 24: PRINT Activate$;: LOCATE 6, 79: PRINT Activate$;
COLOR 10, 1: LOCATE 25, 2: PRINT "<S>ave or <A>bort edit ";
DO: YN$ = UCASE$(INKEY$)
    IF YN$ = "A" THEN CLOSE: GOTO BEBegin
    IF YN$ = "S" THEN EXIT DO
LOOP

'LOCATE 17, 1: PRINT STRING$(50, 32);
LOCATE 14, 33: COLOR 11: PRINT "U P D A T I N G";: COLOR 7
'       Update file
CLOSE 1: OPEN "R", 1, "BIO.DAT", 60
FIELD 1, 30 AS N1$, 10 AS Date1$, 10 AS Date2$, 6 AS ge$, 1 AS Active$, 3 AS Nil$
LSET N1$ = recordedname$
LSET Date1$ = DA1$
LSET Date2$ = da2$
LSET ge$ = Gender$
LSET Active$ = Activate$
LSET Nil$ = "%%%"
PUT 1, SE%
CLOSE #1
RETURN BEBegin


BEcaseconvert:

'    Convert each alphabet character into upper/lower case.
FOR I = 1 TO LEN(NameEntered$)
    S1$ = MID$(NameEntered$, I, 1)
    'IF INSTR(1, NameEntered$, " ") THEN I = 1
    IF I = 1 THEN S1$ = MID$(NameEntered$, I, 1): IF S1$ < CHR$(97) OR S1$ > CHR$(122) THEN GOTO BE880 ELSE MID$(NameEntered$, I, 1) = CHR$(ASC(S1$) - 32)
    IF S1$ = " " THEN I = I + 1: S1$ = MID$(NameEntered$, I, 1): IF S1$ < CHR$(97) OR S1$ > CHR$(122) THEN GOTO BE880 ELSE MID$(NameEntered$, I, 1) = CHR$(ASC(S1$) - 32)
    IF S1$ < CHR$(65) OR S1$ > CHR$(91) THEN GOTO BE880
    MID$(NameEntered$, I, 1) = CHR$(ASC(S1$) + 32)
BE880: NEXT I
RETURN
ErrorPrint:
fff% = FREEFILE
OPEN "error_reports\BioEdit.err" FOR APPEND AS #fff%
PRINT #fff%, " Program Error "; ERR; "in line:"; ERL; "Error Line"; _ERRORLINE; "on "; DATE$; " at "; TIME$
CLOSE #fff%
RESUME NEXT
'------------------------------------------End of BioEdit
'------------------------------------------Begin SetupBio
'exitsignal% = _EXIT
'_ICON
i& = _LOADIMAGE("icons\biorhythm.bmp", 32)
_ICON i&
CLOSE 1


_TITLE "Biorhythm Setup"
'_FULLSCREEN _STRETCH

setupbio: '   BioRhythm Set Up Program Lines
CLEAR
v$ = "4.3": ' Program Version
curdir$ = _CWD$
KEY(1) ON
hm% = 3
ON KEY(1) GOSUB helpfiles:

ON ERROR GOTO BS500

'---------------------------------------------------------------------------

IF _FILEEXISTS(curdir$ + "\biopath.cfg") THEN
    OPEN "i", 1, curdir$ + "\biopath.cfg"
    LINE INPUT #1, Existing$
    LINE INPUT #1, Existing$
    IF RIGHT$(Existing$, 1) = "\" THEN Existing$ = LEFT$(Existing$, LEN(RTRIM$(Existing$)) - 1)
    CLOSE #1
END IF


CLS: X = 0
Zone$(1) = "Newfoundland Time"
Zone$(2) = "Eastern Time"
Zone$(3) = "Central Time"
Zone$(4) = "Mountain Time"
Zone$(5) = "Pacific Time"
Zone$(6) = "Alaskan Time"
Zone$(7) = "Hawaiian Time"
Zone$(8) = "Enter your zone"

CLS: LOCATE 1, 30, 1: PRINT "BioRhythm Setup, V. 4.3"
PRINT
COLOR 15 + 7: PRINT TAB(40 - LEN(Existing) / 2); "("; CHR$(25); "  default "; CHR$(25); ")": COLOR 7, 0
PRINT "Pathname for BIO.DAT datafile (";
IF LEN(Existing$) > 0 THEN AX$ = Existing$ ELSE AX$ = curdir$
AX$ = RTRIM$(AX$)
LOCATE , 32: PRINT AX$; ") : "
PRINT
PRINT "Input Path: ";
LINE INPUT Path1$
IF Path1$ = "" THEN Path1$ = AX$: COLOR 15: PRINT Path1$: COLOR 7
row = CSRLIN: col = POS(col)

IF _DIREXISTS(AX$) THEN
    PRINT
ELSE MKDIR Path1$
END IF
'    AX$ = CURDIR$
CH$ = ""
row = CSRLIN + 1: col = POS(col)
OPEN "r", 2, Path1$ + "\bio.dat", 5
FIELD 2, 5 AS g$
IF LOF(2) / 5 > 0 THEN GOSUB BS300: GOTO BS50
CLOSE #2: OPEN "r", 2, Path1$ + "\BIO.DAT", 600
FIELD 2, 600 AS A$
LSET A$ = "v.4.3  BioRhythm (c)1985-2020 George A. Lee" + STRING$(557, "%")
PUT 2, 1
FOR I = 2 TO 262
    LOCATE row, col: PRINT "Creating file records... Please stand by!  ";
    IF I = 1 THEN FOR X = 1 TO 599: LOCATE row, col + 43: PRINT X;: NEXT X: GOTO BS42
    LOCATE row, col + 43: PRINT USING "###,###"; 157200! - (I * 600);
    LSET A$ = STRING$(600, "%")
    BS42: PUT 2, I
NEXT I
CLOSE #2
BS50: PRINT: PRINT: X = 0
'''FOR tz = 1 TO 4: PRINT USING "#> \               \        #> \               \"; tz; Zone$(tz); tz + 4; Zone$(tz + 4): NEXT tz
'''PRINT: PRINT "Pick a time zone for your printouts: ";
'''BS60: tz$ = INKEY$: IF tz$ = "" THEN GOTO BS60
'''tz = INSTR("12345678", tz$)
'''IF tz = 0 THEN GOTO BS60
'''PRINT tz$
'''TZone$ = Zone$(tz)
'''IF tz = 8 THEN
'''    LINE INPUT "What is your time zone: "; TZone$
'''END IF
'''DMP$ = "LASER"

'TempRow = CSRLIN: LOCATE TempRow, 15: PRINT DMP$
OPEN "o", 1, curdir$ + "\biopath.cfg"
PRINT #1,
PRINT #1, Path1$ + "\"
CLOSE #1
' IF pron THEN 270

'''Pline$ = "1"
'''OPEN "o", 1, curdir$ + "\biochain.ptr"
'''PRINT #1, DMP$
'''PRINT #1, Pline$
'''PRINT #1, TZone$
'''CLOSE #1
'''PRINT: PRINT "You may change these settings anytime by running SETUPBIO.EXE"
PRINT: PRINT "Press ANY KEY to continue...";
CH$ = INPUT$(1)

GOTO BioRhythmMain
BS300: GET 2, 1
IF LEFT$(g$, 5) = "NAME:" THEN CLOSE #2: GOSUB BS900: GOTO BS310
IF MID$(g$, 3, 2) <> mid$(v$,1,2) THEN CLOSE #2: GOSUB BS900: RETURN
BS310: RETURN
BS500:
F% = FREEFILE
OPEN curdir$ + "\error_reports\setupbio.err" FOR APPEND AS #F%
PRINT #F%, " Program Error "; ERR; "in line:"; ERL; "Error Line"; _ERRORLINE; "on "; DATE$; " at "; TIME$
CLOSE #F%
RESUME NEXT
'end of program lines
'---------------------------------------------------------------------------

BS900: PCOPY 0, 1: CLS
LOCATE 5, 1, 1: PRINT "The BIO.DAT file is an older file than this version"
PRINT "After this update, use the 'R'epair option from the EDIT program."
PRINT "Do you want me to update this file? (Y/N) : Y"; CHR$(29);
BS1000: YN$ = UCASE$(INKEY$)
IF YN$ = "" THEN GOTO BS1000
IF YN$ = CHR$(13) THEN YN$ = "Y"
ON INSTR("YN", YN$) GOTO BS1010, BS1240
GOTO BS1000
PRINT
BS1010: F% = FREEFILE
OPEN "R", F%, Path1$ + "\BIO.DAT", 60: l1! = LOF(1) / 60
BS1020: FIELD F%, 30 AS N1$, 10 AS d1$, 10 AS d2$, 6 AS ge$, 1 AS dl$, 3 AS fill$
LSET N1$ = "v." + v$ + " BioRhythm (c)1985-2020 "
LSET d1$ = "George A. "
LSET d2$ = "Lee       "
LSET ge$ = "      "
LSET dl$ = " "
LSET fill$ = "   "
PUT F%, 1
FOR I = 1 TO l1!: IF I = 1 THEN I = 2
    GET 1, I: IF LEFT$(N1$, 2) = CHR$(109) + CHR$(182) THEN GOTO BS1140
    IF LEFT$(N1$, 5) = "NAME:" THEN GOTO BS1140
    IF LEFT$(N1$, 1) = " " THEN GOTO BS1140
    IF INSTR(d1$, CHR$(109) + CHR$(182)) THEN GOTO BS1140
    IF INSTR(d2$, CHR$(109) + CHR$(182)) THEN GOTO BS1140
    IF INSTR(ge$, CHR$(109) + CHR$(182)) THEN GOTO BS1140
    IF INSTR(dl$, CHR$(109) + CHR$(182)) THEN GOTO BS1140
    IF INSTR(fill$, CHR$(109) + CHR$(182)) THEN GOTO BS1140
    IF UCASE$(LEFT$(N1$, 4)) = "NEXT" THEN GOTO BS1140
    GOTO BS1190
    BS1140: LSET N1$ = STRING$(30, "%")
    LSET d1$ = STRING$(10, "%")
    LSET d2$ = STRING$(10, "%")
    LSET ge$ = STRING$(6, "%")
    LSET dl$ = "%"
    BS1190: LSET fill$ = "%%%"
    LOCATE 7, 1: PRINT USING "Repairing: #### !"; I; N1$;
    PUT F%, I
NEXT I
CLOSE #F%
BS1240: PCOPY 1, 0
RETURN
'-----W-----------------------------------------End Of SetUp BioRhythm Lines
'----------------------------------------------------------------Begin ModulePrint
BioPrintModule:
CLEAR
'exitsignal% = _EXIT
i& = _LOADIMAGE("icons\biorhythm.bmp", 32)
_ICON i&
_TITLE "BioRhythm Report Files Print"
KEY(1) ON
hm% = 4
ON KEY(1) GOSUB helpfiles:

COLOR 10, 1
ON ERROR GOTO MPError
ThisFile$ = "Moduleprint.exe"
CLS
LOCATE 2, 10: COLOR 12, 1
PRINT TAB(20); "********* NOTEPAD INSTRUCTIONS *********": PRINT: COLOR 10
PRINT "     While in "; CHR$(34); "Notepad.exe"; CHR$(34); " Use the following commands to Remove the"
PRINT "     Header (which contains the filename) from printing."
PRINT "     REMEMBER to CHANGE IT BACK WHEN YOU ARE FINISHED PRINTING"
PRINT "     THESE FILES (if you want other .txt files to use headers. (Personally,"
PRINT "     I don't like the headers and footers to print on any of my files.)"
PRINT
PRINT "     [";: COLOR 15: PRINT "ALT";: COLOR 10: PRINT "] + ";: COLOR 15: PRINT "f";: COLOR 10: PRINT " (case doesn't matter)": COLOR 15
PRINT "       U";: COLOR 10: PRINT " (case doesn't matter)"
PRINT
PRINT "     Remove the Header's "; CHR$(34);: COLOR 15: PRINT "&f";: COLOR 10: PRINT CHR$(34);
PRINT "(It is best to leave the Footer's ";: PRINT CHR$(34);: COLOR 15: PRINT "Page &p";: COLOR 10: PRINT CHR$(34)
PRINT "     so the pages can be taped together in sequence for display.)"
PRINT: COLOR 11
PRINT TAB(10); "This program will load the chosen file into NotePad.exe where"
PRINT TAB(10); "you can send the file "; CHR$(34); "to the printer "; CHR$(34); "for a more"
PRINT TAB(10); "pleasing print."
PRINT
COLOR 15 + 16: PRINT TAB(6); "NOTE: ";: COLOR 13: PRINT "Once the NOTEPAD.EXE has been opened, YOU MUST close it to"
PRINT TAB(12); "Resume the program."
PRINT
COLOR 15: PRINT TAB(6); "Press Any Key to continue. ";
in$ = INPUT$(1)
IF in$ = CHR$(27) THEN SYSTEM
WIDTH 80, 43: VIEW PRINT 1 TO 43

COLOR 7, 1
CLS
REDIM FileArray$(100)
Spec$ = "graphs\*.txt"
'IF _FILEEXISTS("graphs\*.txt") = 0 THEN
SHELL _HIDE "CMD /C dir " + Spec$ + " /B /X > graphs\filedata.dat"
'END IF
CurWorkDir$ = _CWD$
LOCATE 20, 60: COLOR 14 + 16: PRINT "35 files MAXIMUM";: LOCATE 21, 60: PRINT "are displayed";: COLOR 7
LOCATE 1, 1
COLOR 15: PRINT " Nbr   FileName                ";: COLOR 9: PRINT "(Compatible Chart)       ";: COLOR 10: PRINT "(Single Chart)"
PRINT " ---   ------------------------------------------------------------------------"

OPEN "graphs\filedata.dat" FOR INPUT AS #1
IF EOF(1) = -1 THEN

    CLS
    SOUND 73, 2: SOUND 65, 2
    LOCATE 20, 20: COLOR 12: PRINT "SORRY, there are NO files to print!";
    LOCATE 22, 25: COLOR 7: PRINT "Press ANY Key to continue.";
    DO: SLEEP
        in$ = INKEY$
    LOOP UNTIL in$ <> ""

    CLOSE: KILL "graphs\filedata.dat"

    GOTO BioRhythmMain
END IF
DO UNTIL EOF(1)
    filecount% = filecount% + 1
    LINE INPUT #1, FileArray$(filecount%)
    COLOR 3
    PRINT USING " ##.  "; filecount%;
    COLOR 7
    IF INSTR(FileArray$(filecount%), " and ") THEN COLOR 9 ELSE COLOR 10
    PRINT LEFT$(FileArray$(filecount%), 10) + " " + MID$(FileArray$(filecount%), 15, LEN(FileArray$(filecount%)) - 18)
    IF filecount% = 35 THEN COLOR 7: EXIT DO
LOOP
CLOSE #1
'PRINT: cl = CSRLIN: cp = POS(0)
BMAgain: cl = 45
LOCATE 39, 39: COLOR 13: PRINT "<Enter 0 to quit>";: COLOR 7
LOCATE 39, 30: PRINT "  ";: LOCATE 39, 2
BEEP: COLOR 15: INPUT "Choose which file to print? ", Choice%


LOCATE 42, 1
IF Choice% = 0 THEN
    WIDTH 80, 25: VIEW PRINT 1 TO 25
    GOTO bioprint
END IF
IF ((Choice% >= 1) AND (Choice% <= filecount%)) THEN
    LOCATE 41, 2: PRINT USING "<##> "; Choice%;
    LOCATE 41, 8: COLOR 9: PRINT "You chose: ";: COLOR 14: PRINT FileArray$(Choice%);: COLOR 7:
    LOCATE 39, 1: PRINT SPC(79);: LOCATE 43, 16
ELSE GOTO BMAgain
END IF

Path$ = "%SystemRoot%\system32\notepad.exe " + "graphs\" + FileArray$(Choice%)
SHELL _HIDE Path$
CALL BMAnother
IF Continue$ = "bioprint" THEN SCREEN 80, 25, 0: GOTO bioprint
GOTO BMAgain:
END
MPError: F% = FREEFILE
OPEN "error_reports\moduleprint.err" FOR APPEND AS #F%
PRINT #F%, " Program Error "; ERR; "in line:"; ERL; "Error Line"; _ERRORLINE; "on "; DATE$; " at "; TIME$
CLOSE #F%
RESUME NEXT


' --------------------------------------------------End of Module Print
'----------------------------------------------------Begin BioGraph

biograph:

CLEAR
WIDTH 80, 25: VIEW PRINT 1 TO 25
'exitsignal% = _EXIT
i& = _LOADIMAGE("icons\biorhythm.bmp", 32)
_ICON i&

_TITLE "BioRhythm Graph Screen"
ON ERROR GOTO BioGraphError
REDIM SHARED V
REDIM SHARED P#
'----------------------FUNCTION 1 DEFINITION BEGIN  LINE 460
'----------------------FUNCTION 2 DEFINITION BEGIN LINE 1770
'
' BioGraph.Bas, (C) 1985-2020, GEORGE A LEE, BioRhythm, (575) 623-8365
CDate$ = "1985-2020"
version$ = "Version. 4.3"

KEY(1) ON
hm% = 5
ON KEY(1) GOSUB helpfiles:




'KEY OFF
'ON ERROR GOTO BGFIXIT
ELine = 43: '                                                        Eline=50
BG2: 'WIDTH 80,'                                                                           * ELine
GOTO BG6
BGFIXIT:
IF ELine = 50 THEN ELine = 43: RESUME BG2
IF ELine = 43 THEN ELine = 25: RESUME BG3
RESUME NEXT
BG3: ELine = 25
BG6: '                                                                                     * WIDTH 80, 25
'KEY OFF
LGreen = 10: LGRAY = 7: Cyan = 11: LRed = 12: Magenta = 13: Yellow = 14
REDIM CR$(26), START(26), FINISH(26)
C = 9
FOR I = 1 TO 26
    CR$(I) = CHR$(64 + I)
    START(I) = C + 1
    FINISH(I) = C + 100
    C = C + 100
NEXT I
ON ERROR GOTO BioGraphError
CLS
LOCATE 6, 1, 0
CP$ = "###.##%"
X$ = version$

FOR Delay = 1 TO 3000: NEXT Delay: CLS: WIDTH 80
REDIM A(12), D(12)
CLS


BLOAD "overlays\biograph.bsv":: ' pcopy           Maybe remove the ' mark 0, 1: pcpy = 1
GOTO BG370
PRINT "BIO-RHYTHMS"; TAB(51); "(c) "; CDate$; " by George A. Lee"
FOR B = .2 TO 3 STEP .2
    y = SIN(B)
    PRINT TAB(20 * y + 9); CHR$(1);
    PRINT TAB(40 * y + 10); CHR$(3);
    PRINT TAB(50 * y + 10); CHR$(215);
    ' formula from 'COMPUTER GAMES',J.V.NAHIGIAN,W.S.HODGES
    ' formula translated from TI-99/4a to Model 4 by GEORGE A. LEE, 12/85
NEXT B
PRINT
PRINT "This program can chart your daily BIO-RHYTHMIC patterns, or determine compat-"
PRINT "ability of two individuals.": PRINT STRING$(80, "-");
BG370: FOR I = 1 TO 12
    READ A(I)
NEXT I
FOR I = 1 TO 12
    READ D(I)
NEXT I
DATA 0,31,59,90,120,151,181,212,243,273,304,334
DATA 31,28,31,30,31,30,31,31,30,31,30,31

'----------------------FUNCTION 1 DEFINITION BEGIN--------------------------------
'460 DEF FNA (Z) = CDBL(INT((SIN((V / Z - INT(V / Z)) * P#) + 1) * 13.5))
'470 DEF FNG (Z) = 100 * SIN(V / Z * P#)
'480 DEF FNB = V - 28 * INT(V / 28) + 1
'490 DEF FNC = V - 23 * INT(V / 23) + 1
'500 DEF FND = V - 33 * INT(V / 33) + 1
'----------------------FUNCTION 1 DEFINITION END--------------------------------

WF$ = ""

COLOR Yellow, Black
LOCATE 19, 1
PRINT "<1>  Single person chart"
PRINT "<2>  Two person compatability"
PRINT "<3>  End program"
PRINT "<4>  EDIT file"
LOCATE 25, 29: COLOR LGreen: PRINT "----SCREEN VERSION----";
BG550: ED$ = "4"
IF KY$ = CHR$(27) THEN CLOSE: SYSTEM
LOCATE 23, 1: COLOR Yellow: PRINT "<";: COLOR Magenta: PRINT "5";: COLOR Yellow: PRINT ">";: COLOR Cyan: PRINT "  OOPs, Wanted Printer Verson"
KY$ = INPUT$(1): IF INSTR("12345", KY$) = 0 THEN GOTO BG550
KY = VAL(KY$): LOCATE , , 1
ON KY GOTO BG580, BG2370, BG3300, BG3840, BG3861
BG575: NFME$ = TempName$: TempName$ = ""
BG580: FOR I = 0 TO 4: LOCATE 19 + I, 1: PRINT SPACE$(60);: NEXT I: LOCATE 19, 1: I = 0
IF LEFT$(NFME$, 1) = "m" OR LEFT$(NFME$, 1) = CHR$(0) THEN NFME$ = NE$
BG590: COLOR Yellow, 0: PRINT "Name on chart: "; NFME$ + STRING$(10, 32);: COLOR 7: LOCATE 19, 16: LINE INPUT NE$:
IF NE$ = "" THEN LOCATE 19: GOTO BG590
IF NE$ = "" THEN NE$ = NFME$
GOSUB BG3760: LOCATE 19, 16: PRINT STRING$(27, 32), ;: LOCATE 19, 16: PRINT NE$;
NFME$ = NE$: Name1$ = NE$
'IF WF$="N" THEN 660
GOSUB BG3460
NFME$ = N1$
YB = VAL(MID$(DT1$, 7))

COLOR Cyan, 1: CLS: LOCATE 1, 1: PRINT "This chart specifically printed for "; NE$; "."
PRINT "Compiled on "; DATE$; "      -     "; "(c) "; CDate$; " by George A. Lee"
COLOR LRed: PRINT TAB(12); "Biorhythm is the rhythmic course of the life process of an individual."
PRINT: COLOR Yellow: PRINT "The MEDIAN, line (0), is the critical and is when most accidents MAY occur.": PRINT TAB(12); "The high periods (+) are when you have the most energy, and the low"
PRINT TAB(12); "periods (-) are regarded as recuperative periods.": COLOR Cyan
LOCATE 21, 1: PRINT STRING$(80, 32);: LOCATE 22, 1: PRINT STRING$(80, 32);
LOCATE 21, 1: COLOR LGreen
PRINT "STARTING DATE FOR CHART? (Default=";
COLOR 15: PRINT DATE$;: COLOR LGreen: PRINT ") ";
Sharon1 = POS(Sharon1) + 1: LOCATE , Sharon1: PRINT "   -  -";: COLOR Cyan
BG720: LOCATE , Sharon1: UUU = Sharon1: UU = 20: U = 1: GOSUB BG3320: m = VAL(ab$)
IF m <= 0 THEN m = VAL(DATE$): DD = VAL(MID$(DATE$, 4, 2)): y = VAL(RIGHT$(DATE$, 4)): LOCATE CSRLIN, Sharon1: PRINT DATE$: GOTO BG760
IF (m <= 0) + (m > 12) THEN BEEP: GOTO BG720
Sharon2 = Sharon1 + 3
BG740: LOCATE , Sharon2: U = 1: UUU = Sharon2: GOSUB BG3320: DD = VAL(ab$): IF (DD <= 0) + (DD > 31) THEN BEEP: GOTO BG740
BG750: LOCATE , Sharon2 + 3: U = 3: UUU = Sharon2 + 3: GOSUB BG3320: IF ab$ = "" THEN BEEP: GOTO BG750
y = VAL(ab$)
BG760: ab$ = ""
IF YS > YB THEN GOTO BG1130
DTP = ELine: '15.5
M2 = m
D2 = DD
Y3 = y
Y5 = y
GOSUB BG2170
Z = T
PRINT
IF DT1 > 0 THEN m = DT1: DD = DT2: y = DT3: DT1 = 0: GOTO BG1020
GOSUB BG3910
IF WF$ = "N" THEN GOTO BG910
EGEN$ = "ENTER " + UCASE$(NE$) + "'S GENDER: "
LOCATE 23, 1: PRINT EGEN$ + STRING$(60 - LEN(NE$), 32);
LOCATE 23, LEN(EGEN$) + 2
LINE INPUT Gender$
LOCATE 23, 1: PRINT STRING$(60, 32);
GOSUB BG3870
BG910: IF WF$ = "N" THEN NFME$ = NE$
LOCATE 23, 1: PRINT SPC(70);
LOCATE 23, 1: PRINT "ENTER "; UCASE$(NE$); "'S BIRTHDATE (";: COLOR 15: PRINT "MM-DD-YYYY";: COLOR Cyan: PRINT ") ";
Sharon1 = POS(Sharon1) + 1: LOCATE , Sharon1: PRINT "   -  -";
BG920: LOCATE , Sharon1: UUU = Sharon1: U = 1: UU = CSRLIN - 1: GOSUB BG3320: m = VAL(ab$): IF (m <= 0) + (m > 12) THEN BEEP: GOTO BG920
AD3$ = ab$ + "-": EY$ = ab$: ab$ = "": Sharon2 = Sharon1 + 3
BG940: LOCATE , Sharon2: U = 1: UUU = Sharon2: GOSUB BG3320: DD = VAL(ab$): IF (DD <= 0) + (DD > 31) THEN BEEP: GOTO BG940
AD4$ = ab$ + "-": EY$ = EY$ + ab$: ab$ = ""
BG960: LOCATE , Sharon2 + 3: U = 3: UUU = Sharon2 + 3: GOSUB BG3320: IF ab$ = "" THEN BEEP: GOTO BG960
y = VAL(ab$)
UUU = 0
ab$ = RIGHT$(STR$(y), 4)
AD2$ = AD3$ + AD4$ + ab$
AD1$ = NE$
IF WF$ = "N" THEN GOTO BG1020
GOSUB BG3640
BG1020: PRINT "Any changes (Y/N) ? N";: LOCATE CSRLIN, POS(0) - 1
BG1030: YN$ = INPUT$(1)
IF YN$ = CHR$(13) THEN YN$ = "N"
YN$ = UCASE$(YN$): IF YN$ = "Y" THEN TempName$ = NE$: GOTO BG575 ELSE IF YN$ = "N" THEN GOTO BG1050
GOTO BG1030
BG1050: COLOR 7, 0: ab$ = ""
M1 = m
D1 = DD
Y2 = y
GOTO BG1140
IF AD1$ <> "" THEN GOTO BG1140
BG1130: LOCATE 23, 1: PRINT "******* Don't try to kid me, You weren't born yet!!!! Try again.": PRINT SPACE$(50);: FOR Delay = 1 TO 1000: NEXT Delay: GOTO BG580
BG1140: GOSUB BG2170
IF T > Z THEN GOTO BG1130
V = T - Z
V = ABS(V)

IF ELine > 25 THEN WIDTH 80, ELine
COLOR Cyan, 1: CLS: '*                                                             * view print 1 TO ELine: COLOR Cyan, 1: CLS
PRINT "GRAPH SYMBOLS:  ";: COLOR 12: PRINT CHR$(3);: COLOR 15: PRINT " Physical Cycle (23 day)";: 'chr$(3)
COLOR Yellow: PRINT TAB(51); "(c)"; CDate$; " by George A. Lee"
COLOR 10: PRINT TAB(17); CHR$(1);: COLOR 15: PRINT " Sensitivity (emotional) Cycle (28 day)"
COLOR 11: PRINT TAB(17); CHR$(251);: COLOR 15: PRINT " Cognitive (intellectual) Cycle (33 day)"
COLOR 12: PRINT TAB(17); "*";: COLOR 15: PRINT " Critical day.  Most accidents MAY occur."
IF INSTR(NE$, " ") <= 0 THEN IST = LEN(NE$) ELSE IST = INSTR(NE$, " ") - 1
COLOR LGreen: PRINT LEFT$(NE$, IST); ", "; "you were born on ";
B9 = J + 1
GOSUB BG2110
PRINT AY$; ", ";
A9 = M1
GOSUB BG2080
PRINT MT$;
PRINT STR$(D1) + ","; Y2; "-";
PRINT USING " ######, days OR ###.# years ago."; V; V / 365.25#: PRINT
m$ = "DATE            (-)       (0)       (+)            CAPABILITY %-TILE"
y = 5
X = 0
COLOR 10, 1: LOCATE 6, 1: LOCATE 6, 59: PRINT CHR$(1);: COLOR 11: PRINT "      " + CHR$(251);: COLOR 12: PRINT "      " + CHR$(3) + "     *";: COLOR 15
LOCATE 7, 7: PRINT m$: COLOR 7
J1 = V + J
J1 = J1 - 7 * INT(J1 / 7)
D2 = D2 - 1
J1 = J1 - 1
V = V - 1
FOR I = 1 TO DTP - 10: '                                                               9
    K = 0
    V = V + 1
    D2 = D2 + 1
    J1 = J1 + 1
    IF M2 <> 2 THEN GOTO BG1520
    IF INT(Y3 / 4) <> Y3 / 4 THEN GOTO BG1520
    K = 1
    BG1520: IF D2 <= D(M2) + K THEN GOTO BG1550
    M2 = M2 + 1
    D2 = 1
    BG1550: IF J1 < 7 THEN GOTO BG1570
    J1 = 0
    BG1570: IF M2 <= 12 THEN GOTO BG1620
    Happy$ = "* HAPPY NEW YEAR *"
    Happy = 1
    M2 = 1
    Y3 = Y3 + 1
    BG1620: IF M2 <> M1 THEN GOTO BG1670
    IF D2 <> D1 THEN GOTO BG1670
    Happy$ = "*HAPPY" + STR$(Y3 - Y2) + " BIRTHDAY*"
    Happy = 1
    GOSUB HappyBirthday
    BG1670: IF M2 <> 12 THEN GOTO BG1710
    IF D2 <> 25 THEN GOTO BG1710
    Happy$ = "* MERRY CHRISTMAS *"
    Happy = 1
    BG1710: m$ = STR$(M2) + "-" + STR$(D2)
    IF VAL(RIGHT$(STR$(Y3), 4)) < 10 THEN YR1$ = "000" + RIGHT$(STR$(Y3), 1) ELSE YR1$ = RIGHT$(STR$(Y3), 4)
    COLOR 14: LOCATE 7 + I, 1: PRINT USING " ##_-##_-\  \"; M2; D2; YR1$: COLOR 7
    G = 20
    P# = 6.28318530717961#

    '----------------------FUNCTION2 DEFINITION BEGIN--------------------------------
    C5 = FNABG(33) + G
    S5 = FNABG(28) + G
    P5 = FNABG(23) + G
    LOCATE 7 + I, 34: PRINT CHR$(179);
    CH1$ = CHR$(2): CH2$ = CHR$(1)
    IF S5 > 33 THEN SWAP CH1$, CH2$
    LOCATE 7 + I, S5 + 1: COLOR 10: PRINT CH2$;
    LOCATE 7 + I, 57: PRINT USING "####"; FNGBG(28);: COLOR 7

    LOCATE 7 + I, C5 + 1: COLOR 11: PRINT CHR$(251);
    LOCATE 7 + I, 64: PRINT USING "####"; FNGBG(33);: COLOR 7

    LOCATE 7 + I, P5 + 1: COLOR 12: PRINT CHR$(3);
    LOCATE 7 + I, 71: PRINT USING "####"; FNGBG(23);: COLOR 7

    IF (S5 = 33) + (P5 = 33) + (C5 = 33) THEN LOCATE 7 + I, 79: COLOR 12 + 16: PRINT "*";: COLOR 7

    IF FNGBG(28) = FNGBG(33) THEN LOCATE 7 + I, S5 + 1: PRINT " ";
    IF FNGBG(28) = FNGBG(23) THEN LOCATE 7 + I, S5 + 1: PRINT " ";
    IF FNGBG(23) = FNGBG(33) THEN LOCATE 7 + I, P5 + 1: PRINT " ";
    '----------------------FUNCTION2 DEFINITION END--------------------------------



    IF Happy THEN GOSUB BG2130
    IF M2 <> 1 THEN GOTO BG1980
    IF D2 <> 1 THEN GOTO BG1980
    m$ = "* HAPPY NEW YEAR *"
    GOSUB BG2140
BG1980: NEXT I
LOCATE ELine - LastLine - 3: COLOR 10: PRINT "For an EXTENDED chart, please use the Printer Option."
BG1990: m$ = "Another chart? (Y/n) "
LOCATE ELine - LastLine, 1: PRINT STRING$(70, 32);

LOCATE ELine - LastLine, 1: COLOR 15: PRINT m$;
LastLine = 0
COLOR 7, 0
BG2020: KY$ = INKEY$
IF KY$ = "" THEN GOTO BG2020
IF KY$ = CHR$(13) THEN KY$ = "Y"
IF UCASE$(KY$) = "N" THEN CLS: GOTO BioRhythmMain: '                               * THEN WIDTH 80,25
IF UCASE$(KY$) = "Y" THEN GOTO biograph
GOTO BG2020

BG2080: MONTH$ = "JanFebMarAprMayJunJulAugSepOctNovDec"
MT$ = MID$(MONTH$, A9 * 3 - 2, 3)
RETURN
BG2110: DDAY$ = "WedThuFriSatSunMonTue"
AY$ = MID$(DDAY$, B9 * 3 - 2, 3): RETURN
BG2130: IF Happy THEN SWAP m$, Happy$
BG2140: LOCATE 7 + I, 1:
IF Happy THEN COLOR LGreen + 16
BG2145: IF INSTR(m$, "NEW YEAR") THEN COLOR LRed + 16
PRINT m$;
COLOR 7
Happy = 0
RETURN
BG2170: y1 = y - 1800
Q1 = INT(y1 / 4)
Q2 = INT(Q1 / 25)
Q3 = INT((y1 + 200) / 400)
K = 0
IF Q1 * 4 <> y1 THEN GOTO BG2260
IF Q2 * 100 <> y1 THEN GOTO BG2260
IF Q3 * 400 - 200 <> y1 THEN GOTO BG2260
K = 1
BG2260: T = 365 * y1 + Q1 - Q2 + Q3 - K
T = T + A(m) + DD - 1
IF m < 3 THEN GOTO BG2300
T = T + K
BG2300: IF INT(y1 / 4) <> y1 / 4 THEN GOTO BG2330
IF m > 2 THEN GOTO BG2330
T = T - 1
BG2330: J = T - 7 * INT(T / 7)
RETURN
END
BG2370: COLOR Cyan, 1: CLS
PRINT "                 C O M P A T A B I L I T Y    A N A L Y S I S"
PRINT
COLOR Yellow
PRINT "          Two individuals will have an average compatability of 100%"
PRINT "       ONLY if they were born on the same day, or if they were born"
PRINT "       21,252 days (58.1848 Years) apart.  ";
PRINT "Please do not be upset if": PRINT "       your compatability average is less than 100%!"
PRINT: IF NFME$ = "" THEN NFME$ = Name1$
COLOR Cyan
LOCATE 10, 16: PRINT "What is person one's name?  "; NFME$ + STRING$(8, 32);
ThisLine = CSRLIN
BG2461: LOCATE ThisLine, 44: LINE INPUT A1$
IF A1$ = "" THEN A1$ = NFME$: GOTO BG2461
NE$ = A1$: Name1$ = NE$
GOSUB BG3760
A1$ = NE$
NFME$ = A1$

GOSUB BG3460
IF DT1 > 0 THEN SWAP A1$, N2$
IF DT1 > 0 THEN m = DT1: DD = DT2: y = DT3: DT1 = 0: GOTO BG2620
GOSUB BG3910
IF WF$ = "N" THEN GOTO BG2560
LOCATE 11, 16: PRINT "ENTER GENDER: ";: LINE INPUT Gender$: GOSUB BG3870
BG2560: LOCATE 11, 16: PRINT "What is "; A1$; "'s ";
PRINT "birthday (MM-DD-YYYY): ";: ' m, DD, y: IF LEN(LTRIM$(STR$(y))) < 4 THEN 2560
CALL DOBBG(MONIN, DAYIN, YEARIN)
m = MONIN: DD = DAYIN: y = YEARIN

IF m < 10 THEN AD3$ = "0" + RIGHT$(STR$(m), 1) ELSE AD3$ = RIGHT$(STR$(m), 4)
IF DD < 10 THEN AD4$ = "0" + RIGHT$(STR$(DD), 1) ELSE AD4$ = RIGHT$(STR$(DD), 4)
AD1$ = A1$: AD2$ = AD3$ + "-" + AD4$ + "-" + RIGHT$(STR$(y), 4)
IF WF$ = "N" THEN GOTO BG2620
GOSUB BG3640
BG2620: E1 = m
F1 = DD
G1 = y
GOSUB BG2170
Z2 = T
K1 = J + 1
PRINT: IF NFM1$ = "" THEN NFM1$ = Name2$
LOCATE 14, 16: PRINT "What is person two's name?  "; NFM1$ + STRING$(10, 32);
ThisLine = CSRLIN
BG2695: LOCATE ThisLine, 44: LINE INPUT B1$: IF B1$ = "" THEN B1$ = NFM1$
IF B1$ = "" THEN GOTO BG2695
NE$ = B1$: Name2$ = NE$
GOSUB BG3760
B1$ = NE$
NFM1$ = B1$
GOSUB BG3460
IF DT1 > 0 THEN SWAP B1$, N2$
IF DT1 > 0 THEN m = DT1: DD = DT2: y = DT3: DT1 = 0: GOTO BG2860
GOSUB BG3910
IF WF$ = "N" THEN GOTO BG2790
LOCATE 15, 16: PRINT "ENTER GENDER: " + STRING$(50, 32);
ThisLine = CSRLIN
LOCATE ThisLine, 30: LINE INPUT Gender$: GOSUB BG3870
BG2790: LOCATE 15, 16: PRINT "What is "; B1$; "'s ";

PRINT "birthday  (MM-DD-YYYY) ";

CALL DOBBG(MONIN, DAYIN, YEARIN)
m = MONIN: DD = DAYIN: y = YEARIN:: ' IF LEN(LTRIM$(STR$(y))) < 4 THEN 2790
'ThisLine = CSRLIN
'GOSUB 6000


IF m < 10 THEN AD3$ = "0" + RIGHT$(STR$(m), 1) ELSE AD3$ = RIGHT$(STR$(m), 4)
IF DD < 10 THEN AD4$ = "0" + RIGHT$(STR$(DD), 1) ELSE AD4$ = RIGHT$(STR$(DD), 4)
AD1$ = B1$: AD2$ = AD3$ + "-" + AD4$ + "-" + RIGHT$(STR$(y), 4)
IF WF$ = "N" THEN GOTO BG2860
GOSUB BG3640
BG2860: E2 = m
D2 = DD
G2 = y
GOSUB BG2170
P2 = ABS(Z2 - T)
K2 = J + 1
COLOR 7, 0: CLS: BLOAD "overlays\biocomp.bsv"
LOCATE 11, 28: COLOR LGreen: PRINT A1$; " and "; B1$; ".";: COLOR LGRAY
LOCATE 13, 15: COLOR LGreen: PRINT A1$;: COLOR LGRAY: PRINT " was born on ";
B9 = K1
GOSUB BG2110
COLOR LRed: PRINT AY$;: COLOR LGRAY: PRINT ", ";
A9 = E1
GOSUB BG2080
PRINT MT$;
PRINT STR$(F1); ","; G1;
LOCATE 14, 15: COLOR LGreen: PRINT B1$;: COLOR LGRAY: PRINT " was born on ";
B9 = K2
GOSUB BG2110
COLOR LRed: PRINT AY$;: COLOR LGRAY: PRINT ", ";
A9 = E2
GOSUB BG2080
PRINT MT$;
PRINT STR$(D2); ","; G2;
Z = P2
P3 = ABS(INT(((Z / 23) - INT(Z / 23)) * 23))
S3 = ABS(INT(((Z / 28) - INT(Z / 28)) * 28))
C3 = ABS(INT(((Z / 33) - INT(Z / 33)) * 33))
P5 = ABS(100 - ((2 * P3) * (100 / 23)))
S5 = ABS(100 - ((2 * S3) * (100 / 28)))
C5 = ABS(100 - ((2 * C3) * (100 / 33)))
COLOR LRed: LOCATE 16, 55: PRINT USING CP$; P5
COLOR Cyan: LOCATE 17, 55: PRINT USING CP$; S5
COLOR Yellow: LOCATE 18, 55: PRINT USING CP$; C5
LOCATE 20, 55
A5 = (P5 + S5 + C5) / 3
COLOR Magenta: PRINT USING CP$; A5;: COLOR LGRAY
IF ELine = 43 THEN LastLine = 18
IF ELine = 25 THEN LastLine = 0
IF ELine = 50 THEN LastLine = 25
GOTO BG1990
BG3300:
CLOSE: GOTO BioRhythmMain

BG3320: LOCATE UU + 1, UUU + 1: PRINT STRING$(LEN(ab$), 32);: LOCATE UU + 1, UUU + 1
ab$ = ""
FOR I = 0 TO U
    BG3360: m$ = INPUT$(1)
    IF m$ = CHR$(13) THEN GOTO BG3420
    IF m$ = CHR$(29) THEN GOTO BG3320
    IF m$ = CHR$(8) THEN m$ = CHR$(29): GOTO BG3320
    IF (m$ = " ") + (m$ = "'") THEN GOTO BG3390
    IF (ASC(UCASE$(m$)) < 48) + (ASC(UCASE$(m$)) > 90) THEN BEEP: GOTO BG3360
    BG3390: ab$ = ab$ + m$
    LOCATE UU + 1, UUU + I + 1: PRINT m$;
NEXT I
BG3420: IF U = 3 THEN
    IF (LEN(ab$)) < 4 THEN GOTO BG3320
END IF
IF U < 3 AND m$ = CHR$(13) THEN GOTO BG3440
IF U < 3 THEN PRINT "-"; ELSE PRINT
BG3440: RETURN
BG3460: CLOSE #1: OPEN "R", 1, pat2$ + "BIO.DAT", 60
N1$ = ""
FIELD 1, 30 AS N1$, 10 AS d1$, 10 AS d2$, 6 AS ge$, 1 AS dl$
DT1 = 0
GH = ASC(NE$) - 64
IF START(GH) = 1 THEN START(GH) = 2
FOR SE = START(GH) TO FINISH(GH)
    IF EOF(1) THEN GOTO BG3620
    GET 1, SE
    IF LEFT$(N1$, 2) = "%%" THEN GOTO BG3620
    IF dl$ = "I" THEN PIX = SE: GOTO BG3580
    IF INSTR(1, N1$, NE$) <> 0 THEN GOTO BG3590
BG3580: NEXT SE
BG3590: N2$ = LEFT$(N1$, INSTR(1, N1$, "  ") - 1)
NE$ = N2$
DT1 = VAL(MID$(d1$, 1, 2)): DT2 = VAL(MID$(d1$, 4, 2)): DT3 = VAL(RIGHT$(d1$, 4))
BG3620: CLOSE #1
RETURN


'----------------------------------------------------------------------------------------add record ????????????????
BG3640: ON ERROR GOTO BioGraphError
CLOSE 1: OPEN "R", 1, pat2$ + "BIO.DAT", 60
FIELD 1, 30 AS N1$, 10 AS d1$, 10 AS d2$, 6 AS ge$, 1 AS dl$, 3 AS Nil$
IF PIX THEN SE = PIX
PIX = 0
LSET N1$ = AD1$
LSET d1$ = AD2$
LSET d2$ = LEFT$(DATE$, 6) + RIGHT$(DATE$, 4)
LSET ge$ = Gender$
LSET dl$ = "A"
IF SE = 1 THEN SE = 2

PUT 1, SE
CLOSE #1
RETURN
'--------------------------------------------------------------------------------------End of add record????????????????????

BG3760: FOR I = 1 TO LEN(NE$)
    S1$ = MID$(NE$, I, 1)
    IF I = 1 THEN S1$ = MID$(NE$, I, 1): IF S1$ < CHR$(97) OR S1$ > CHR$(122) THEN GOTO BG3820 ELSE MID$(NE$, I, 1) = CHR$(ASC(S1$) - 32)
    IF S1$ = " " THEN I = I + 1: S1$ = MID$(NE$, I, 1): IF S1$ < CHR$(97) OR S1$ > CHR$(122) THEN GOTO BG3820 ELSE MID$(NE$, I, 1) = CHR$(ASC(S1$) - 32)
    IF S1$ < CHR$(65) OR S1$ > CHR$(91) THEN GOTO BG3820
    MID$(NE$, I, 1) = CHR$(ASC(S1$) + 32)
BG3820: NEXT I
RETURN
BG3840: CLOSE
CLS: LOCATE 12, 31: PRINT "Loading Editor...";
GOTO BioEdit
BG3861: CLOSE: CLS: LOCATE 12, 31: PRINT "Loading Printout Program...": CLEAR: GOTO bioprint

BG3870: IF Gender$ = "" THEN Gender$ = "E"
IF MID$(Gender$, 1, 1) = "M" THEN Gender$ = "Male"
IF MID$(Gender$, 1, 1) = "F" THEN Gender$ = "Female"
MID$(Gender$, 1, 1) = UCASE$(LEFT$(Gender$, 1)): MID$(Gender$, 2) = LCASE$(MID$(Gender$, 2))
RETURN
BioGraphError: F% = FREEFILE: ' ERROR ROUTINE
OPEN "error_reports\BioGraph.err" FOR APPEND AS #F%
PRINT #F%, " Program Error "; ERR; "in line:"; ERL; "Error Line"; _ERRORLINE; "on "; DATE$; " at "; TIME$
CLOSE #F%
RESUME NEXT
BG3910: BEEP: NOF$ = " is not on file.  Do you want to file (Y/N) ?"
LOCATE 23, 1: PRINT NE$; NOF$;
BG3911: WF$ = UCASE$(INKEY$): IF WF$ = "" THEN GOTO BG3911
IF INSTR("YN", WF$) = 0 THEN GOTO BG3911
LOCATE 23, 1: PRINT STRING$(79, 32);
RETURN

BG6000: LOCATE ThisLine: 'LOCATE UU + 1, UUU + 1: PRINT STRING$(LEN(ab$), 32);: LOCATE UU + 1, UUU + 1
Temp$ = "": ' ab$ = ""
FOR I = 0 TO U
    BG6030: m$ = INPUT$(1)
    IF m$ = CHR$(13) THEN GOTO BG6120
    IF m$ = CHR$(29) THEN GOTO BG6000
    IF m$ = CHR$(8) THEN m$ = CHR$(29): GOTO BG6000
    IF (m$ = " ") + (m$ = "'") THEN GOTO BG6090
    IF (ASC(UCASE$(m$)) < 48) + (ASC(UCASE$(m$)) > 90) THEN BEEP: GOTO BG6030
    BG6090: Temp$ = Temp$ + m$
    LOCATE UU + 1, UUU + I + 1: PRINT m$;
NEXT I
BG6120: IF U = 3 THEN
    IF (LEN(Temp$)) < 4 THEN GOTO BG6000
END IF
IF ThisLine < 3 AND m$ = CHR$(13) THEN RETURN: '6170
IF ThisLine < 3 THEN PRINT "-"; ELSE PRINT
RETURN
'------------------------------------------------- END OF BioGraph Program
'------------------------------------------------- BEGIN BIOPRINT
'exitsignal% = _EXIT
i& = _LOADIMAGE("icons\biorhythm.bmp", 32)
_ICON i&
bioprint:
_TITLE "BioRhythm Print Graph Module"
CLEAR
KEY(1) ON
hm% = 6
ON KEY(1) GOSUB helpfiles:

'timenow1$ = DATE$
'TimeNow$ = RIGHT$(timenow1$, 4) + "-" + LEFT$(timenow1$, 3) + MID$(timenow1$, 4, 2) + "_"

REDIM SHARED FileName$
'REDIM SHARED V
'REDIM SHARED P#
REDIM CR$(26), START(26), FINISH(26)
CALL CheckDirBP
'--------------(OLD)---FUNCTION 1 DEFINITION BEGIN LINE 1482
'----------------------FUNCTION 2 DEFINITION BEGIN LINE 1766
'
' BioPrint.Bas, (C) 1985-2020, GEORGE A LEE, BioRhythm, (575) 623-8365
CDate$ = "1985-2020"
version$ = "Version. 4.3"

IF _FILEEXISTS("skipit.flg") THEN KILL "skipit.flg": GOTO BP2

BLOAD "overlays\loadprnt.bsv"
COLOR 15: Rept$ = "NOTE: This version WILL load the Notepad.exe "
LOCATE 12, 7: PRINT CHR$(179); TAB(16); Rept$
LOCATE 13, 7: PRINT CHR$(179); TAB(16); "from where you can print the report to your   "; 'TAB(28); SPC(41);
LOCATE 14, 7: PRINT CHR$(179); TAB(16); "printer.  This gives you a better looking     "; 'TAB(28); SPC(41);
LOCATE 15, 7: PRINT CHR$(179); TAB(16); "report than the LPRINT method.                "; 'TAB(28); SPC(41);
LOCATE 16, 7: PRINT CHR$(179); TAB(16); " Have Fun!                                    "; 'TAB(28); SPC(41);
LOCATE 17, 7: PRINT CHR$(179); TAB(16); "                                              "; 'TAB(28); SPC(41);
Rept = 0
LOCATE 23, 55
Rept$ = INPUT$(1)
BP2: Rept$ = ""

'KEY OFF
ON ERROR GOTO BPFIXIT
ELine = 25
GOTO BP6
BPFIXIT:
ELine = 25
'IF ELine = 50 THEN ELine = 43: RESUME BP2
'IF ELine = 43 THEN ELine = 25: RESUME BP3
RESUME NEXT
BP3: ELine = 25
BP6: 'WIDTH 80, 25
'KEY OFF
timenow1$ = DATE$
TimeNow$ = RIGHT$(timenow1$, 4) + "-" + LEFT$(timenow1$, 3) + MID$(timenow1$, 4, 2) + "_"

LGreen = 10: LGRAY = 7: Cyan = 11: LRed = 12: Magenta = 13: Yellow = 14: White = 15
REDIM CR$(26), START(26), FINISH(26)
C = 9
FOR I = 1 TO 26
    CR$(I) = CHR$(64 + I)
    START(I) = C + 1
    FINISH(I) = C + 100
    C = C + 100
NEXT I
ON ERROR GOTO BP3900
CLS
LOCATE 6, 1, 0
CP$ = "###.##%"
X$ = version$

REDIM A(12), D(12)
CLS
'235 VIEW PRINT 1 TO ELine
'WIDTH 80, 25: VIEW PRINT 1 TO ELine: LOCATE , , 0
'IF pcpy AND ELine = 25 THEN PCOPY 1, 0: GOTO 370
BLOAD "overlays\biograph.bsv": ' PCOPY 0, 1: pcpy = 1
GOTO BP370
PRINT "BIO-RHYTHMS"; TAB(51); "(c) "; CDate$; " by George A. Lee"
FOR B = .2 TO 3 STEP .2
    y = SIN(B)
    PRINT TAB(20 * y + 9); CHR$(1);
    PRINT TAB(40 * y + 10); CHR$(3);
    PRINT TAB(50 * y + 10); CHR$(215);
    ' formula from 'COMPUTER GAMES',J.V.NAHIGIAN,W.S.HODGES
    ' formula translated from TI-99/4a to Model 4 by GEORGE A. LEE, 12/85
NEXT B
PRINT
PRINT "This program can chart your daily BIO-RHYTHMIC patterns, or determine compat-"
PRINT "ability of two individuals.": PRINT STRING$(80, "-");
BP370: FOR I = 1 TO 12
    READ A(I)
NEXT I
FOR I = 1 TO 12
    READ D(I)
NEXT I
DATA 0,31,59,90,120,151,181,212,243,273,304,334
DATA 31,28,31,30,31,30,31,31,30,31,30,31

'----------------------FUNCTION 1 DEFINITION BEGIN--------------------------------
'460 DEF FNA (Z) = CDBL(INT((SIN((V / Z - INT(V / Z)) * P#) + 1) * 13.5))
'470 DEF FNG (Z) = 100 * SIN(V / Z * P#)
'480 DEF FNB = V - 28 * INT(V / 28) + 1
'490 DEF FNC = V - 23 * INT(V / 23) + 1
'500 DEF FND = V - 33 * INT(V / 33) + 1
'----------------------FUNCTION 1 DEFINITION END--------------------------------

WF$ = ""
'GOTO 550
Reports = 1: Rept$ = "6"
COLOR Yellow, Black
LOCATE 19, 1
PRINT "<1>  Single person chart"
PRINT "<2>  Two person compatability"
PRINT "<3>  End program"
PRINT "<4>  EDIT file"
LOCATE 19, 40: COLOR Yellow: PRINT "<";: COLOR Magenta: PRINT "5";: COLOR Yellow: PRINT ">";: COLOR Cyan: PRINT " OOPs, Wanted Screen Verson"
LOCATE 20, 40: COLOR Yellow: PRINT "<";: COLOR 10: PRINT "6";: COLOR Yellow: PRINT "> Print Charts."
LOCATE 25, 29: COLOR LGreen: PRINT "----PRINTER VERSION----";
BP550: ED$ = "4": Reports = 0

KY$ = ""

KY$ = INPUT$(1)
IF KY$ = CHR$(27) THEN CLOSE: SYSTEM
IF INSTR("123456", KY$) = 0 THEN GOTO BP550
KY = VAL(KY$): LOCATE , , 1
ON KY GOTO BP580, BP2370, BP3319, BP3840, BP3861, BP3845
' 1 single chart, 2 compat chart, 3 end program, 4 edit file, 5 OOPs want Screen, 6 ModulePrintBP
BP575: NFME$ = TempName$: TempName$ = ""
BP580: FOR I = 0 TO 4: LOCATE 19 + I, 1: PRINT SPACE$(79);: NEXT I: LOCATE 19, 1: I = 0
IF LEFT$(NFME$, 1) = "m" OR LEFT$(NFME$, 1) = CHR$(37) THEN NFME$ = NE$
BP590: COLOR Yellow, 0: PRINT "Name on chart: "; NFME$ + STRING$(10, 32);: COLOR 7: LOCATE 19, 16: LINE INPUT NE$:
IF NE$ = "" THEN NE$ = NFME$
IF NE$ = "" THEN LOCATE 19: GOTO BP590

GOSUB BP3760: LOCATE 19, 16: PRINT STRING$(27, 32), ;: LOCATE 19, 16: PRINT NE$;
NFME$ = NE$: Name1$ = NE$
'IF WF$="N" THEN 660
GOSUB BP3460
NFME$ = N1$
YB = VAL(MID$(DT1$, 7))

COLOR Cyan, 1: CLS: LOCATE 1, 1: PRINT "This chart specifically printed for "; NE$; "."
PRINT "Compiled on "; DATE$; "      -     "; "(c) "; CDate$; " by George A. Lee"
COLOR LRed: PRINT TAB(12); "Biorhythm is the rhythmic course of the life process of an individual."
PRINT: COLOR Yellow: PRINT "The MEDIAN, line (0), is the critical and is when most accidents MAY occur."
PRINT TAB(12); "The high periods (+) are when you have the most energy, and the low"
PRINT TAB(12); "periods (-) are regarded as recuperative periods.": COLOR Cyan
LOCATE 21, 1: PRINT STRING$(80, 32);: LOCATE 22, 1: PRINT STRING$(80, 32);
LOCATE 21, 1: COLOR LGreen
PRINT "STARTING DATE FOR CHART? (Default=";
COLOR 15: PRINT DATE$;: COLOR LGreen: PRINT ") ";
Sharon1 = POS(Sharon1) + 1: LOCATE , Sharon1: PRINT "   -  -";: COLOR Cyan
BP720: LOCATE , Sharon1: UUU = Sharon1: UU = 20: U = 1: GOSUB BP3320
ThisDate$ = ab$
m = VAL(ab$): IF m <= 0 THEN m = VAL(DATE$): DD = VAL(MID$(DATE$, 4, 2)): y = VAL(RIGHT$(DATE$, 4)): LOCATE CSRLIN, Sharon1: PRINT DATE$: GOTO BP760
IF (m <= 0) + (m > 12) THEN BEEP: GOTO BP720
Sharon2 = Sharon1 + 3
BP740: LOCATE , Sharon2: U = 1: UUU = Sharon2: GOSUB BP3320: DD = VAL(ab$): ThisDate$ = ThisDate$ + ab$: IF (DD <= 0) + (DD > 31) THEN BEEP: GOTO BP740
BP750: LOCATE , Sharon2 + 3: U = 3: UUU = Sharon2 + 3: GOSUB BP3320: IF ab$ = "" THEN BEEP: GOTO BP750
y = VAL(ab$): ThisDate$ = ThisDate$ + ab$: ThisDate$ = RIGHT$(ThisDate$, 4) + "-" + LEFT$(ThisDate$, 2) + "-" + MID$(ThisDate$, 3, 2) + "_"
BP760: ab$ = ""
IF YS > YB THEN GOTO BP1130
'DTP = ELine: '15.5

COLOR LGreen
PRINT "HOW MANY MONTHS (";
COLOR White
PRINT "@30.5";
COLOR Yellow
PRINT " DAYS PER MONTH";
COLOR LGreen
PRINT ")? 1";


CALL PlaceCursor
COLOR LGRAY


LINE INPUT dtp$
DTP = INT(VAL(dtp$))
IF DTP = 0 THEN DTP = 1
DTP = INT(DTP * 30.5 + .5)
'PRINT dtp
'LINE INPUT Paus$
'ELine = dtp


M2 = m
D2 = DD
Y3 = y
Y5 = y
GOSUB BP2170
Z = T
PRINT
IF DT1 > 0 THEN m = DT1: DD = DT2: y = DT3: DT1 = 0: GOTO BP1020
GOSUB BP3910
IF WF$ = "N" THEN GOTO BP910
EGEN$ = "ENTER " + UCASE$(NE$) + "'S GENDER: "
LOCATE 23, 1: PRINT EGEN$ + STRING$(60 - LEN(NE$), 32);: LOCATE 23, LEN(EGEN$) + 2: LINE INPUT Gender$: LOCATE 23, 1: PRINT STRING$(60, 32);
GOSUB BP3870

BP910: IF WF$ = "N" THEN NFME$ = NE$
LOCATE 23, 1: PRINT SPC(70);
LOCATE 23, 1: PRINT "ENTER "; UCASE$(NE$); "'S BIRTHDATE (";: COLOR 15: PRINT "MM-DD-YYYY";: COLOR Cyan: PRINT ") ";
Sharon1 = POS(Sharon1) + 1: LOCATE , Sharon1: PRINT "   -  -";
BP920: LOCATE , Sharon1: UUU = Sharon1: U = 1: UU = CSRLIN - 1: GOSUB BP3320: m = VAL(ab$): IF (m <= 0) + (m > 12) THEN BEEP: GOTO BP920
AD3$ = ab$ + "-": EY$ = ab$: ab$ = "": Sharon2 = Sharon1 + 3
BP940: LOCATE , Sharon2: U = 1: UUU = Sharon2: GOSUB BP3320: DD = VAL(ab$): IF (DD <= 0) + (DD > 31) THEN BEEP: GOTO BP940
AD4$ = ab$ + "-": EY$ = EY$ + ab$: ab$ = ""
BP960: LOCATE , Sharon2 + 3: U = 3: UUU = Sharon2 + 3: GOSUB BP3320: IF ab$ = "" THEN BEEP: GOTO BP960
y = VAL(ab$)
UUU = 0
ab$ = RIGHT$(STR$(y), 4)
AD2$ = AD3$ + AD4$ + ab$
AD1$ = NE$
IF WF$ = "N" THEN GOTO BP1020
GOSUB BP3640
BP1020: PRINT "Any changes (Y/N) ? N";: LOCATE CSRLIN, POS(0) - 1
BP1030: YN$ = INPUT$(1)
IF YN$ = CHR$(13) THEN YN$ = "N"
YN$ = UCASE$(YN$): IF YN$ = "Y" THEN TempName$ = NE$: GOTO BP575 ELSE IF YN$ = "N" THEN CLS: COLOR 7, 1: GOTO BP1050
GOTO BP1030
BP1050: ':GOTO BP1030
COLOR 7, 0: ab$ = ""
M1 = m
D1 = DD
Y2 = y
GOTO BP1140
IF AD1$ <> "" THEN GOTO BP1140
BP1130: SOUND 262, 5: SOUND 131, 5: SOUND 65, 10

COLOR 12, 1: LOCATE 12, 8: PRINT "******* Don't try to kid me, You weren't born yet!!!! Try again."
'PRINT SPACE$(50);
COLOR 7: LOCATE 13, 27: PRINT "Press ANY key to continue."
WHILE INKEY$ = "": WEND
xxx% = FREEFILE
OPEN "O", xxx%, "skipit.flg": PRINT #xxx%, "skipit": CLOSE #xxx%: xxx% = 0

CLOSE: CLS: GOTO bioprint

BP1140: GOSUB BP2170
IF T > Z THEN GOTO BP1130
V = T - Z
V = ABS(V)

'1180 IF ELine > 25 THEN WIDTH 80, ELine
'VIEW PRINT 1 TO ELine: COLOR Cyan, 1: CLS

COLOR Yellow: PRINT TAB(51); "(c)"; CDate$; " by George A. Lee"
CLOSE #F%
'F% = FREEFILE: '                                                                      For Printer print
IF LEN(ThisDate$) > 0 THEN TimeNow5$ = ThisDate$ ELSE TimeNow5$ = TimeNow$
FileName$ = TimeNow5$ + "SC " + NE$ + ".TXT": singlechart$ = FileName$
OPEN "graphs\" + FileName$ FOR OUTPUT AS #7
TimeNow5$ = ""
PRINT #7,
PRINT #7,
PRINT #7, "BBBBBB   IIII   OOOOO   RRRRRR   HH   HH  YY    YY  TTTTTTTT  HH   HH  MM    MM"
PRINT #7, "BB   BB   II   OO   OO  RR   RR  HH   HH   YY  YY      TT     HH   HH  MM    MM"
PRINT #7, "BB   BB   II   OO   OO  RR   RR  HH   HH    YYYY       TT     HH   HH  MMM  MMM"
PRINT #7, "BBBBB     II   OO   OO  RRRRR    HHHHHHH     YY        TT     HHHHHHH  MMMMMMMM"
PRINT #7, "BBBBBB    II   OO   OO  RRRRR    HHHHHHH     YY        TT     HHHHHHH  MMMMMMMM"
PRINT #7, "BB   BB   II   OO   OO  RRRR     HH   HH     YY        TT     HH   HH  MM MM MM"
PRINT #7, "BB   BB   II   OO   OO  RR RR    HH   HH     YY        TT     HH   HH  MM    MM"
PRINT #7, "BBBBBB   IIII   OOOOO   RR  RR   HH   HH     YY        TT     HH   MM  MM    MM"
PRINT #7, " "
PRINT #7, "        Version 4.3                        (c) 1985-2020 by George A. Lee"
PRINT #7, " "
PRINT #7, "   BioRhythm is the rhythmic course of the life process of an individual."
PRINT #7, "   The MEDIAN, line (0), is the critical and is when most accidents are most"
PRINT #7, "   likely to occur.  The high periods (+) are when you have the most energy,"
PRINT #7, "   and the low periods (-) are regarded as recuperative periods."
PRINT #7, ""
PRINT #7, "   (No warranties are either expressed or implied). Use of this software is"
PRINT #7, "   for entertainment purposes only."
PRINT #7,
PRINT #7,
PRINT #7, "GRAPH SYMBOLS:"; TAB(17); "P = Physical Cycle (23 day)"
PRINT #7, TAB(17); "E = Sensitivity (emotional) Cycle (28 day)"
PRINT #7, TAB(17); "I = Cognitive (intellectual) Cycle (33 day)"
PRINT #7, TAB(17); "*"; " Critical day.  Most accidents MAY occur."
PRINT #7, TAB(17); "*, ** or *** indicate how many chriticals per One day"
PRINT #7,
PRINT #7,
PRINT #7, "CAPABILITY Percentile repreresents the degree of positive and negative energy"
PRINT #7, "you have at the point in that cycle.  When the cycle switches polarity,"
PRINT #7, "(Negative to Positive or Positive to Negative),  you are at a CRITICAL point"
PRINT #7, "which is the point of greatest risk in the cycle."
PRINT #7,
PRINT #7,
PRINT #7,
PRINT #7, "This chart specifically printed for "; NE$; "."
PRINT #7, "Compiled on "; DATE$; "      -     "; "(c) "; CDate$; " by George A. Lee"
PRINT #7,
COLOR , 1
LOCATE 5, 1: PRINT "GRAPH SYMBOLS:";: COLOR 12, 1: PRINT TAB(17); CHR$(80);: COLOR 15, 1: PRINT " Physical Cycle (23 day)": 'CHR$(3);
COLOR 10, 1: PRINT TAB(17); CHR$(69);: COLOR 15, 1: PRINT " Sensitivity (emotional) Cycle (28 day)": 'CHR$(1);
COLOR 11, 1: PRINT TAB(17); CHR$(73);: COLOR 15, 1: PRINT " Cognitive (intellectual) Cycle (33 day)": 'CHR$(251);
COLOR 12, 1: PRINT TAB(17); "*";: COLOR 15, 1: PRINT " Critical day.  Most accidents MAY occur."
IF INSTR(NE$, " ") <= 0 THEN IST = LEN(NE$) ELSE IST = INSTR(NE$, " ") - 1
LOCATE CSRLIN + 2, 1
COLOR LGreen, 1: PRINT LEFT$(NE$, IST); ", "; "you were born on ";
'                                                                      For Printer print
PRINT #7, LEFT$(NE$, IST); ", "; "you were born on: "
B9 = J + 1
GOSUB BP2110: 'CALL PickDay
'                                                                      For Printer print
PRINT #7, AY$; ",  ";

PRINT AY$; ", ";
A9 = M1
GOSUB BP2080
'                                                                      For Printer print
PRINT #7, MT$; STR$(D1) + ","; Y2; "-";
PRINT #7, USING " ######, days OR ###.# years ago."; V; V / 365.25#: PRINT #7,

PRINT MT$;
PRINT STR$(D1) + ","; Y2; "-";
PRINT USING " ######, days OR ###.# years ago."; V; V / 365.25#: PRINT
LOCATE CSRLIN, 1
PRINT "Your Report has been sent to a FILE named: "; CHR$(34);:
COLOR White, 1: PRINT singlechart$;: COLOR Yellow: PRINT CHR$(34);
PRINT "(in the 'graph\' directory and to the Printer.  If you wish to"
PRINT "keep the file for later viewing or to print again using your"
PRINT "favorite 'NotePad.exe' type software."
PRINT
PRINT "Please RE-NAME it before running another graph."

'1340 Start3$ = "DATE            (-)       (0)       (+)            CAPABILITY %-TILE": 'm$
mfile$ = "DATE    Day in Cycle  (-)         (0)          (+)   CAPABILITY PERCENT"
Line$ = "______________________________________________________________________________"
y = 5
X = 0
'1370 COLOR 10, 1: LOCATE 6, 1: LOCATE 6, 59: PRINT CHR$(1);: COLOR 11: PRINT "      " + CHR$(251);: COLOR 12: PRINT "      " + CHR$(3) + "     *";
'PRINT #7, TAB(14); "E"; TAB(19); "I"; TAB(24); "P"; TAB(59); "E"; TAB(66); "I"; TAB(73); "P" + "   *";
'                                                                      For Printer print
PRINT #7, TAB(5); mfile$
PRINT #7, TAB(2); Line$
Lcount = 43
'1380 LOCATE LineCount, 10: PRINT Start3$: COLOR 7
J1 = V + J
J1 = J1 - 7 * INT(J1 / 7)
D2 = D2 - 1
J1 = J1 - 1
V = V - 1
FOR I = 1 TO DTP: ' - 9

    K = 0
    V = V + 1
    D2 = D2 + 1
    J1 = J1 + 1
    IF M2 <> 2 THEN GOTO BP1520
    IF INT(Y3 / 4) <> Y3 / 4 THEN GOTO BP1520
    K = 1
    BP1520: IF D2 <= D(M2) + K THEN GOTO BP1550
    M2 = M2 + 1
    D2 = 1
    BP1550: IF J1 < 7 THEN GOTO BP1570
    J1 = 0
    BP1570: IF M2 <= 12 THEN GOTO BP1620
    'Happy$ = "* HAPPY NEW YEAR *"
    'Happy = 1
    M2 = 1
    Y3 = Y3 + 1
    BP1620: IF M2 <> M1 THEN GOTO BP1670
    IF D2 + 1 <> D1 THEN GOTO BP1670
    Happy$ = "*HAPPY" + STR$(Y3 - Y2) + " BIRTHDAY*"
    Happy = 1
    GOSUB HappyBirthday
    'SOUND 659, 5: _DELAY .3: SOUND 659, 3: SOUND 740, 3: _DELAY .3: SOUND 659, 3: SOUND 880, 5: _DELAY .3: SOUND 831, 5: _DELAY .6
    'SOUND 659, 7: _DELAY .3: SOUND 659, 3: SOUND 740, 3: _DELAY .3: SOUND 659, 3: SOUND 988, 3: _DELAY .6: SOUND 880, 7: _DELAY .6
    'SOUND 659, 7: _DELAY .3: SOUND 659, 3: SOUND 1318, 3: _DELAY .4: SOUND 1109, 3: _DELAY .2: SOUND 880, 3: _DELAY .1: SOUND 831, 7: _DELAY .2: SOUND 740, 7: _DELAY .4
    'SOUND 1175, 7: _DELAY .3: SOUND 1175, 3: SOUND 1109, 9: _DELAY .6: SOUND 880, 9: _DELAY .7: SOUND 988, 9: _DELAY .7: SOUND 880, 9: _DELAY .7
    '_DELAY 1




    'PUT 'HAPPY BIRTHDAY' SONG IN HERE : Bday.wav
    'h& = _SNDOPEN("Bday.wav")

    'IF h& THEN _SNDPLAY h&
    '_SNDCLOSE h&
    BP1670: IF M2 <> 12 THEN GOTO BP1710
    IF D2 <> 25 THEN GOTO BP1710
    'Happy$ = "* MERRY CHRISTMAS *"
    'Happy = 1
    BP1710: m$ = STR$(M2) + "-" + STR$(D2)
    IF VAL(RIGHT$(STR$(Y3), 4)) < 10 THEN YR1$ = "000" + RIGHT$(STR$(Y3), 1) ELSE YR1$ = RIGHT$(STR$(Y3), 4)
    'IF i > Lcount THEN LOCATE LineCount, 1 ELSE LOCATE LineCount, 1
    '1730 LOCATE LineCount, 1: COLOR 14: PRINT USING " ##_/##_/\  \"; M2; D2; YR1$;: COLOR 7
    G = 20
    P# = 6.28318530717961#

    '----------------------FUNCTION2 DEFINITION BEGIN--------------------------------
    C5 = FNABP(33) + G
    S5 = FNABP(28) + G
    P5 = FNABP(23) + G
    '1800 LOCATE LineCount, 34: PRINT CHR$(179);
    CH1$ = CHR$(2): CH2$ = CHR$(1)
    IF S5 > 33 THEN SWAP CH1$, CH2$
    '1830 LOCATE LineCount, S5 + 1: COLOR 10: PRINT CH2$;
    '1840 LOCATE LineCount, 57: PRINT USING "####"; FNGBP(28);: COLOR 7
    '1850 LOCATE LineCount, C5 + 1: COLOR 11: PRINT CHR$(251);
    '1860 LOCATE LineCount, 64: PRINT USING "####"; FNGBP(33);: COLOR 7
    '1870 LOCATE LineCount, P5 + 1: COLOR 12: PRINT CHR$(3);
    '1880 LOCATE LineCount, 71: PRINT USING "####"; FNGBP(23);: COLOR 7
    IF (S5 = 33) + (P5 = 33) + (C5 = 33) THEN Combined = 1 ELSE Combined = 0
    '1890 IF Combined THEN LOCATE LineCount, 79: COLOR 12 + 16: PRINT "*";: COLOR 7
    '1900 IF FNGBP(28) = FNGBP(33) THEN LOCATE LineCount, S5 + 1: PRINT " ";
    '1910 IF FNGBP(28) = FNGBP(23) THEN LOCATE LineCount, S5 + 1: PRINT " ";
    '1920 IF FNGBP(23) = FNGBP(33) THEN LOCATE LineCount, P5 + 1: PRINT " ";
    '----------------------FUNCTION2 DEFINITION END--------------------------------

    '                                                                      For Printer print
    pstr$ = " ##/##/\  \  ##  ##  ##                                 ####   ####   ####     "
    pstn = 7
    MID$(pstr$, 40, 1) = "|"
    IF FNGBP(28) = -100 THEN pstn = 6 ELSE pstn = 7
    MID$(pstr$, S5 + pstn, 1) = CHR$(69)
    IF FNGBP(33) = -100 THEN pstn = 6 ELSE pstn = 7
    MID$(pstr$, C5 + pstn, 1) = CHR$(73)
    IF FNGBP(23) = -100 THEN pstn = 6 ELSE pstn = 7
    MID$(pstr$, P5 + pstn, 1) = CHR$(80)
    IF S5 = 33 THEN MID$(pstr$, 77, 1) = "*"
    IF P5 = 33 THEN MID$(pstr$, 78, 1) = "*"
    IF C5 = 33 THEN MID$(pstr$, 79, 1) = "*"
    pstn = 7
    'IF MID$(pstr$, 78, 1) = " " THEN MID$(pstr$, 78, 2) = MID$(pstr$, 79, 1) + " "
    'IF MID$(pstr$, 77, 1) = " " THEN MID$(pstr$, 77, 3) = MID$(pstr$, 78, 2) + " "
    IF M2 = 12 AND D2 = 25 THEN m$ = "**** MERRY CHRISTMAS ****": PRINT #7, m$
    IF M2 = 1 AND D2 = 1 THEN m$ = "*** HAPPY NEW YEAR ***": PRINT #7, m$
    'GOSUB BP2140

    PRINT #7, USING pstr$; M2; D2; YR1$; FNBBP; FNDBP; FNCBP; FNGBP(28); FNGBP(33); FNGBP(23)
    IF Happy THEN GOSUB BP2130: Happy = 0
    'IF M2 <> 1 THEN GOTO BP1980
    'IF D2 <> 1 THEN GOTO BP1980
    'm$ = "* HAPPY NEW YEAR *"
    'GOSUB BP2140
BP1980: NEXT I
PRINT #7, TAB(2); Line$
PRINT #7, TAB(14); "E"; TAB(19); "I"; TAB(24); "P"; TAB(59); "E"; TAB(66); "I"; TAB(73); "P" + "   *";
PRINT #7, TAB(5); mfile$
CLOSE #7: CALL PFSBP
FileName$ = ""
BP1991: m$ = "Another chart? (Y/n) ": KY$ = ""
BP2000: LOCATE 25, 1: PRINT STRING$(70, 32);
LOCATE 25, 1: COLOR 15: PRINT m$;
LastLine = 0
COLOR 7, 0
BP2020: KY$ = INKEY$
IF KY$ = CHR$(27) THEN CLOSE: SYSTEM
IF KY$ = "" THEN GOTO BP2020
IF KY$ = CHR$(13) THEN KY$ = "Y"
IF UCASE$(KY$) = "N" THEN CLS: CLOSE: GOTO BioRhythmMain
IF UCASE$(KY$) = "Y" THEN
    xxx% = FREEFILE
    OPEN "O", xxx%, "skipit.flg": PRINT #xxx%, "skipit": CLOSE #xxx%: xxx% = 0

    CLOSE: CLS: GOTO bioprint
END IF
GOTO BP2020
CLS: CLOSE: LOCATE , , 0:

GOTO BioRhythmMain
BP2080: MONTH$ = "JanFebMarAprMayJunJulAugSepOctNovDec"
MT$ = MID$(MONTH$, A9 * 3 - 2, 3)
RETURN
BP2110: DDAY$ = "WedThuFriSatSunMonTue"
AY$ = MID$(DDAY$, B9 * 3 - 2, 3)
RETURN
BP2130: IF Happy THEN SWAP m$, Happy$
BP2140: PRINT #7, m$
IF Happy THEN COLOR LGreen + 16
COLOR 7
Happy = 0
RETURN
BP2170: y1 = y - 1800
Q1 = INT(y1 / 4)
Q2 = INT(Q1 / 25)
Q3 = INT((y1 + 200) / 400)
K = 0
IF Q1 * 4 <> y1 THEN GOTO BP2260
IF Q2 * 100 <> y1 THEN GOTO BP2260
IF Q3 * 400 - 200 <> y1 THEN GOTO BP2260
K = 1
BP2260: T = 365 * y1 + Q1 - Q2 + Q3 - K
T = T + A(m) + DD - 1
IF m < 3 THEN GOTO BP2300
T = T + K
BP2300: IF INT(y1 / 4) <> y1 / 4 THEN GOTO BP2330
IF m > 2 THEN GOTO BP2330
T = T - 1
BP2330: J = T - 7 * INT(T / 7)
RETURN
END
BP2370: COLOR Cyan, 1: CLS
: '                                                                      For Printer print


PRINT "                 C O M P A T A B I L I T Y    A N A L Y S I S"
PRINT
COLOR Yellow
PRINT "          Two individuals will have an average compatability of 100%"
PRINT "       ONLY if they were born on the same day, or if they were born"
PRINT "       21,252 days (58.1848 Years) apart.  ";
PRINT "       Please do not be upset if your compatability average is less"
PRINT "       than 100%!"
PRINT: IF NFME$ = "" THEN NFME$ = Name1$
COLOR Cyan
LOCATE 10, 16: PRINT "What is person one's name?  "; NFME$ + STRING$(8, 32);
BP2461: ThisLine = CSRLIN
LOCATE ThisLine, 44: LINE INPUT A1$
IF A1$ = "" THEN A1$ = NFME$: GOTO BP2461
NE$ = A1$: Name1$ = NE$
GOSUB BP3760
A1$ = NE$
NFME$ = A1$
'IF INSTR(A1$," ")>0 THEN 2550
GOSUB BP3460
IF DT1 > 0 THEN SWAP A1$, N2$
IF DT1 > 0 THEN m = DT1: DD = DT2: y = DT3: DT1 = 0: GOTO BP2620
GOSUB BP3910
IF WF$ = "N" THEN GOTO BP2560
LOCATE 11, 16: PRINT "ENTER GENDER: ";: LINE INPUT Gender$: GOSUB BP3870
BP2560: LOCATE 11, 16: PRINT "What is "; A1$; "'s ";
PRINT "birthday (MM-DD-YYYY) ";: ' m, DD, y: IF LEN(LTRIM$(STR$(y))) < 4 THEN 2560
CALL DOBBP(MONIN, DAYIN, YEARIN)
m = MONIN: DD = DAYIN: y = YEARIN
'ThisLine = CSRLIN
'GOSUB 6000
'PRINT Temp$


IF m < 10 THEN AD3$ = "0" + RIGHT$(STR$(m), 1) ELSE AD3$ = RIGHT$(STR$(m), 4)
IF DD < 10 THEN AD4$ = "0" + RIGHT$(STR$(DD), 1) ELSE AD4$ = RIGHT$(STR$(DD), 4)
AD1$ = A1$: AD2$ = AD3$ + "-" + AD4$ + "-" + RIGHT$(STR$(y), 4)
IF WF$ = "N" THEN GOTO BP2620
GOSUB BP3640
BP2620: E1 = m
F1 = DD
G1 = y
GOSUB BP2170
Z2 = T
K1 = J + 1
PRINT: IF NFM1$ = "" THEN NFM1$ = Name2$
LOCATE 14, 16: PRINT "What is person two's name?  "; NFM1$ + STRING$(10, 32);
ThisLine = CSRLIN
BP2695: LOCATE ThisLine, 44: LINE INPUT B1$: IF B1$ = "" THEN B1$ = NFM1$
IF B1$ = "" THEN GOTO BP2695
NE$ = B1$: Name2$ = NE$
GOSUB BP3760
B1$ = NE$
NFM1$ = B1$
GOSUB BP3460
IF DT1 > 0 THEN SWAP B1$, N2$
IF DT1 > 0 THEN m = DT1: DD = DT2: y = DT3: DT1 = 0: GOTO BP2860
GOSUB BP3910
IF WF$ = "N" THEN GOTO BP2790
LOCATE 15, 16: PRINT "ENTER GENDER: " + STRING$(50, 32);
ThisLine = CSRLIN
LOCATE ThisLine, 30: LINE INPUT Gender$: GOSUB BP3870
BP2790: LOCATE 15, 16: PRINT "What is "; B1$; "'s ";
PRINT "birthday  (MM-DD-YYYY) ";: ' m, DD, y: IF LEN(LTRIM$(STR$(y))) < 4 THEN 2790
'ThisLine = CSRLIN
'GOSUB 6000
CALL DOBBP(MONIN, DAYIN, YEARIN)
m = MONIN: DD = DAYIN: y = YEARIN
IF m < 10 THEN AD3$ = "0" + RIGHT$(STR$(m), 1) ELSE AD3$ = RIGHT$(STR$(m), 4)
IF DD < 10 THEN AD4$ = "0" + RIGHT$(STR$(DD), 1) ELSE AD4$ = RIGHT$(STR$(DD), 4)
AD1$ = B1$: AD2$ = AD3$ + "-" + AD4$ + "-" + RIGHT$(STR$(y), 4)
IF WF$ = "N" THEN GOTO BP2860
GOSUB BP3640

BP2860: E2 = m
D2 = DD
G2 = y
GOSUB BP2170
P2 = ABS(Z2 - T)
K2 = J + 1
'                                 COMPATIBILITY SECTION
COLOR 7, 0: CLS: BLOAD "overlays\biocomp.bsv"
LOCATE 11, 28: COLOR LGreen: PRINT A1$; " and "; B1$; ".";: COLOR LGRAY
LOCATE 13, 15: COLOR LGreen: PRINT A1$;: COLOR LGRAY: PRINT " was born on ";

B9 = K1
GOSUB BP2110: 'CALL PickDay
COLOR LRed: PRINT AY$;: COLOR LGRAY: PRINT ", ";
CompatDay1$ = AY$
A9 = E1
GOSUB BP2080
PRINT MT$;
CompatMonth1$ = MT$
CompatYear1$ = STR$(G1)
PRINT STR$(F1); ","; G1;
LOCATE 14, 15: COLOR LGreen: PRINT B1$;: COLOR LGRAY: PRINT " was born on ";
B9 = K2
GOSUB BP2110
COLOR LRed: PRINT AY$;: COLOR LGRAY: PRINT ", ";
CompatDay2$ = AY$
A9 = E2
GOSUB BP2080
PRINT MT$;
PRINT STR$(D2); ","; G2;
CompatMonth2$ = MT$
CompatYear2$ = STR$(G2)
Z = P2
P3 = ABS(INT(((Z / 23) - INT(Z / 23)) * 23))
S3 = ABS(INT(((Z / 28) - INT(Z / 28)) * 28))
C3 = ABS(INT(((Z / 33) - INT(Z / 33)) * 33))
P5 = ABS(100 - ((2 * P3) * (100 / 23)))
S5 = ABS(100 - ((2 * S3) * (100 / 28)))
C5 = ABS(100 - ((2 * C3) * (100 / 33)))
COLOR LRed: LOCATE 16, 55: PRINT USING CP$; P5: Compat1 = P5
IF ELine = 43 THEN LastLine = 18
IF ELine = 25 THEN LastLine = 0
IF ELine = 50 THEN LastLine = 25

COLOR Cyan: LOCATE 17, 55: PRINT USING CP$; S5: Compat2 = S5
COLOR Yellow: LOCATE 18, 55: PRINT USING CP$; C5: Compat3 = C5
LOCATE 20, 55
A5 = (P5 + S5 + C5) / 3
COLOR Magenta: PRINT USING CP$; A5;: COLOR LGRAY: Compat4 = A5

FileName$ = TimeNow$ + "CP " + A1$ + " and " + B1$ + ".TXT"
OPEN "graphs\" + FileName$ FOR OUTPUT AS #8
PRINT #8,: PRINT #8,: PRINT #8,
PRINT #8, "BBBBBB   IIII   OOOOO   RRRRRR   HH   HH  YY    YY  TTTTTTTT  HH   HH  MM    MM"
PRINT #8, "BB   BB   II   OO   OO  RR   RR  HH   HH   YY  YY      TT     HH   HH  MM    MM"
PRINT #8, "BB   BB   II   OO   OO  RR   RR  HH   HH    YYYY       TT     HH   HH  MMM  MMM"
PRINT #8, "BBBBB     II   OO   OO  RRRRR    HHHHHHH     YY        TT     HHHHHHH  MMMMMMMM"
PRINT #8, "BBBBBB    II   OO   OO  RRRRR    HHHHHHH     YY        TT     HHHHHHH  MMMMMMMM"
PRINT #8, "BB   BB   II   OO   OO  RRRR     HH   HH     YY        TT     HH   HH  MM MM MM"
PRINT #8, "BB   BB   II   OO   OO  RR RR    HH   HH     YY        TT     HH   HH  MM    MM"
PRINT #8, "BBBBBB   IIII   OOOOO   RR  RR   HH   HH     YY        TT     HH   MM  MM    MM"
PRINT #8, " "
PRINT #8, "        Version 4.3                        (c) 1985-2020 by George A. Lee"
PRINT #8, " "
PRINT #8, ""
PRINT #8, "   (No warranties are either expressed or implied). Use of this software is"
PRINT #8, "   for entertainment purposes only."
PRINT #8,
PRINT #8,
PRINT #8, "                 C O M P A T A B I L I T Y    A N A L Y S I S"
PRINT #8,
PRINT #8, "          Two individuals will have an average compatability of 100%"
PRINT #8, "       ONLY if they were born on the same day, or if they were born"
PRINT #8, "       21,252 days (58.1848 Years) apart.  Please do not be upset if"
PRINT #8, "       your compatability average is less than 100%!"

PCT$ = "###.##%"
PRINT #8,
PRINT #8, TAB(3); STRING$(74, 95)
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(CENTERBP); "ANALYSIS OF "; A1$; " AND "; B1$; "."; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(7); A1$; " was born on ";
IF CompatDay1$ = "Sun" THEN CompatDay1$ = "Sunday": GOTO BP3275
IF CompatDay1$ = "Mon" THEN CompatDay1$ = "Monday": GOTO BP3275
IF CompatDay1$ = "Tue" THEN CompatDay1$ = "Tuesday": GOTO BP3275
IF CompatDay1$ = "Wed" THEN CompatDay1$ = "Wednesday": GOTO BP3275
IF CompatDay1$ = "Thu" THEN CompatDay1$ = "Thursday": GOTO BP3275
IF CompatDay1$ = "Fri" THEN CompatDay1$ = "Friday": GOTO BP3275
IF CompatDay1$ = "Sat" THEN CompatDay1$ = "Saturday"
BP3275: IF CompatMonth1$ = "Jan" THEN CompatMonth1$ = "January": GOTO BP3276
IF CompatMonth1$ = "Jan" THEN CompatMonth1$ = "January": GOTO BP3276
IF CompatMonth1$ = "Feb" THEN CompatMonth1$ = "February": GOTO BP3276
IF CompatMonth1$ = "Mar" THEN CompatMonth1$ = "March": GOTO BP3276
IF CompatMonth1$ = "Apr" THEN CompatMonth1$ = "April": GOTO BP3276
IF CompatMonth1$ = "May" THEN CompatMonth1$ = "May": GOTO BP3276
IF CompatMonth1$ = "Jun" THEN CompatMonth1$ = "June": GOTO BP3276
IF CompatMonth1$ = "Jul" THEN CompatMonth1$ = "July": GOTO BP3276
IF CompatMonth1$ = "Aug" THEN CompatMonth1$ = "August": GOTO BP3276
IF CompatMonth1$ = "Sep" THEN CompatMonth1$ = "September": GOTO BP3276
IF CompatMonth1$ = "Oct" THEN CompatMonth1$ = "October": GOTO BP3276
IF CompatMonth1$ = "Nov" THEN CompatMonth1$ = "November": GOTO BP3276
IF CompatMonth1$ = "Dec" THEN CompatMonth1$ = "December"
BP3276: PRINT #8, CompatDay1$; ", "; CompatMonth1$; STR$(F1); ","; CompatYear1$; TAB(76); "|": '= : 'ZN$(E1);
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(7); B1$; " was born on ";
IF CompatDay2$ = "Sun" THEN CompatDay2$ = "Sunday": GOTO BP3277
IF CompatDay2$ = "Mon" THEN CompatDay2$ = "Monday": GOTO BP3277
IF CompatDay2$ = "Tue" THEN CompatDay2$ = "Tuesday": GOTO BP3277
IF CompatDay2$ = "Wed" THEN CompatDay2$ = "Wednesday": GOTO BP3277
IF CompatDay2$ = "Thu" THEN CompatDay2$ = "Thursday": GOTO BP3277
IF CompatDay2$ = "Fri" THEN CompatDay2$ = "Friday": GOTO BP3277
IF CompatDay2$ = "Sat" THEN CompatDay2$ = "Saturday"
BP3277: IF CompatMonth2$ = "Jan" THEN CompatMonth2$ = "January": GOTO BP3278
IF CompatMonth2$ = "Jan" THEN CompatMonth2$ = "January": GOTO BP3278
IF CompatMonth2$ = "Feb" THEN CompatMonth2$ = "February": GOTO BP3278
IF CompatMonth2$ = "Mar" THEN CompatMonth2$ = "March": GOTO BP3278
IF CompatMonth2$ = "Apr" THEN CompatMonth2$ = "April": GOTO BP3278
IF CompatMonth2$ = "May" THEN CompatMonth2$ = "May": GOTO BP3278
IF CompatMonth2$ = "Jun" THEN CompatMonth2$ = "June": GOTO BP3278
IF CompatMonth2$ = "Jul" THEN CompatMonth2$ = "July": GOTO BP3278
IF CompatMonth2$ = "Aug" THEN CompatMonth2$ = "August": GOTO BP3278
IF CompatMonth2$ = "Sep" THEN CompatMonth2$ = "September": GOTO BP3278
IF CompatMonth2$ = "Oct" THEN CompatMonth2$ = "October": GOTO BP3278
IF CompatMonth2$ = "Nov" THEN CompatMonth2$ = "November": GOTO BP3278
IF CompatMonth2$ = "Dec" THEN CompatMonth2$ = "December"
BP3278: PRINT #8, CompatDay2$; ", "; CompatMonth2$; STR$(D2); ","; CompatYear2$; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(14);: PRINT #8, USING "PHYSICAL COMPATIBILITY (23-DAY CYCLE) IS   " + PCT$; P5;: PRINT #8, TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|";: PRINT #8, TAB(14); USING "EMOTIONAL COMPATABILITY (28-DAY CYCLE) IS  " + PCT$; S5;: PRINT #8, TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|";: PRINT #8, TAB(14); USING "COGNITIVE COMPATABILITY (33-DAY CYCLE) IS  " + PCT$; C5;: PRINT #8, TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(56); " ======="; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
A5 = (P5 + S5 + C5) / 3
PRINT #8, TAB(3); "|"; TAB(24); "AVG. COMPATABILITY  "; TAB(57);: PRINT #8, USING PCT$; A5;: PRINT #8, TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); "|"; TAB(76); "|"
PRINT #8, TAB(3); STRING$(74, 95)
CLOSE #8
CALL PFCBP
FileName$ = ""


GOTO BP1991
BP3319: CLOSE: GOTO BioRhythmMain

BP3320: LOCATE UU + 1, UUU + 1: PRINT STRING$(LEN(ab$), 32);: LOCATE UU + 1, UUU + 1
ab$ = ""
FOR I = 0 TO U
    BP3360: m$ = INPUT$(1)
    IF m$ = CHR$(13) THEN GOTO BP3420
    IF m$ = CHR$(29) THEN GOTO BP3320
    IF m$ = CHR$(8) THEN m$ = CHR$(29): GOTO BP3320
    IF (m$ = " ") + (m$ = "'") THEN GOTO BP3390
    IF (ASC(UCASE$(m$)) < 48) + (ASC(UCASE$(m$)) > 90) THEN BEEP: GOTO BP3360
    BP3390: ab$ = ab$ + m$
    LOCATE UU + 1, UUU + I + 1: PRINT m$;
NEXT I
BP3420: IF U = 3 THEN
    IF (LEN(ab$)) < 4 THEN GOTO BP3320
END IF
IF U < 3 AND m$ = CHR$(13) THEN GOTO BP3440
IF U < 3 THEN PRINT "-"; ELSE PRINT
BP3440: RETURN
BP3460: CLOSE #1: OPEN "R", 1, pat2$ + "BIO.DAT", 60
BP3470: N1$ = ""
FIELD 1, 30 AS N1$, 10 AS d1$, 10 AS d2$, 6 AS ge$, 1 AS dl$, 3 AS Nil$
DT1 = 0
GH = ASC(NE$) - 64
FOR SE = START(GH) TO FINISH(GH)
    IF EOF(1) THEN GOTO BP3620
    GET 1, SE
    IF LEFT$(N1$, 2) = "%%" THEN GOTO BP3620
    IF dl$ = "I" THEN PIX = SE: GOTO BP3580
    IF INSTR(1, N1$, NE$) <> 0 THEN GOTO BP3590
BP3580: NEXT SE
BP3590: N2$ = LEFT$(N1$, INSTR(1, N1$, "  ") - 1)
NE$ = N2$
DT1 = VAL(MID$(d1$, 1, 2)): DT2 = VAL(MID$(d1$, 4, 2)): DT3 = VAL(RIGHT$(d1$, 4))
BP3620: CLOSE #1
RETURN
BP3640: ON ERROR GOTO BP3900
CLOSE #1: OPEN "R", 1, pat2$ + "BIO.DAT", 60
FIELD 1, 30 AS N1$, 10 AS d1$, 10 AS d2$, 6 AS ge$, 1 AS dl$, 3 AS Nil$
IF PIX THEN SE = PIX
PIX = 0
LSET N1$ = AD1$
LSET d1$ = AD2$
LSET d2$ = LEFT$(DATE$, 6) + RIGHT$(DATE$, 4)
LSET ge$ = Gender$
LSET dl$ = "A"
LSET Nil$ = "%%%"
PUT 1, SE
CLOSE #1
RETURN
BP3760: FOR I = 1 TO LEN(NE$)
    S1$ = MID$(NE$, I, 1)
    IF I = 1 THEN S1$ = MID$(NE$, I, 1): IF S1$ < CHR$(97) OR S1$ > CHR$(122) THEN GOTO BP3820 ELSE MID$(NE$, I, 1) = CHR$(ASC(S1$) - 32)
    IF S1$ = " " THEN I = I + 1: S1$ = MID$(NE$, I, 1): IF S1$ < CHR$(97) OR S1$ > CHR$(122) THEN GOTO BP3820 ELSE MID$(NE$, I, 1) = CHR$(ASC(S1$) - 32)
    IF S1$ < CHR$(65) OR S1$ > CHR$(91) THEN GOTO BP3820
    MID$(NE$, I, 1) = CHR$(ASC(S1$) + 32)
BP3820: NEXT I
RETURN
BP3840: CLOSE: '----------------------------------------------goto bioedit
CLOSE

GOTO BioEdit
BP3845: CLOSE: GOTO BioPrintModule: '                                                                            Module
BP3850: CLS: LOCATE 12, 31: PRINT "Loading Editor...";

GOTO BioEdit
BP3861: CLOSE: CLS: LOCATE 12, 31: PRINT "Loading Screen Program..."

CLOSE: GOTO biograph

BP3870: IF Gender$ = "" THEN Gender$ = "E"
IF MID$(Gender$, 1, 1) = "M" THEN Gender$ = "Male"
IF MID$(Gender$, 1, 1) = "F" THEN Gender$ = "Female"
MID$(Gender$, 1, 1) = UCASE$(LEFT$(Gender$, 1)): MID$(Gender$, 2) = LCASE$(MID$(Gender$, 2))
RETURN
BP3900: F% = FREEFILE
OPEN "error_reports\BioPrint.err" FOR APPEND AS #F%
PRINT #F%, " Program Error "; ERR; "in line:"; ERL; "Error Line"; _ERRORLINE; "on "; DATE$; " at "; TIME$
CLOSE #F%
RESUME NEXT
BP3910: BEEP: NOF$ = " is not on file.  Do you want to file (Y/N) ?"
LOCATE 23, 1: PRINT NE$; NOF$;
BP3911: WF$ = UCASE$(INKEY$): IF WF$ = "" THEN GOTO BP3911
IF INSTR("YN", WF$) = 0 THEN GOTO BP3911
LOCATE 23, 1: PRINT STRING$(79, 32);
RETURN

BP6000: LOCATE ThisLine: 'LOCATE UU + 1, UUU + 1: PRINT STRING$(LEN(ab$), 32);: LOCATE UU + 1, UUU + 1
Temp$ = "": ' ab$ = ""
FOR I = 0 TO U
    BP6030: m$ = INPUT$(1)
    IF m$ = CHR$(13) THEN GOTO BP6120
    IF m$ = CHR$(29) THEN GOTO BP6000
    IF m$ = CHR$(8) THEN m$ = CHR$(29): GOTO BP6000
    IF (m$ = " ") + (m$ = "'") THEN GOTO BP6090
    IF (ASC(UCASE$(m$)) < 48) + (ASC(UCASE$(m$)) > 90) THEN BEEP: GOTO BP6030
    BP6090: Temp$ = Temp$ + m$
    LOCATE UU + 1, UUU + I + 1: PRINT m$;
NEXT I
BP6120: IF U = 3 THEN
    IF (LEN(Temp$)) < 4 THEN GOTO BP6000
END IF
IF ThisLine < 3 AND m$ = CHR$(13) THEN GOTO BP6170
IF ThisLine < 3 THEN PRINT "-"; ELSE PRINT
BP6170: RETURN
RETURN
HappyBirthday:
SOUND 659, 5: _DELAY .3: SOUND 659, 3: SOUND 740, 3: _DELAY .3: SOUND 659, 3: SOUND 880, 5: _DELAY .3: SOUND 831, 5: _DELAY .6
SOUND 659, 7: _DELAY .3: SOUND 659, 3: SOUND 740, 3: _DELAY .3: SOUND 659, 3: SOUND 988, 3: _DELAY .6: SOUND 880, 7: _DELAY .6
SOUND 659, 7: _DELAY .3: SOUND 659, 3: SOUND 1318, 3: _DELAY .4: SOUND 1109, 3: _DELAY .2: SOUND 880, 3: _DELAY .1: SOUND 831, 7: _DELAY .2: SOUND 740, 7: _DELAY .4
SOUND 1175, 7: _DELAY .3: SOUND 1175, 3: SOUND 1109, 9: _DELAY .6: SOUND 880, 9: _DELAY .7: SOUND 988, 9: _DELAY .7: SOUND 880, 9: _DELAY .7
_DELAY 1
RETURN

helpfiles:

IF hm% = 1 THEN SHELL _HIDE "CMD /C help_files\biorhythmmain.html": RETURN
IF hm% = 2 THEN SHELL _HIDE "CMD /C help_files\bioedit.html": RETURN
IF hm% = 3 THEN SHELL _HIDE "CMD /C help_files\setupbio.html": RETURN
IF hm% = 4 THEN SHELL _HIDE "CMD /C help_files\bioprintmodule.html": RETURN
IF hm% = 5 THEN SHELL _HIDE "CMD /C help_files\biographscreen.html": RETURN
IF hm% = 6 THEN SHELL _HIDE "CMD /C help_files\biographprint.html": RETURN
'gohome:
RETURN
theory:
SHELL _HIDE "CMD /C help_files\theory.html"
RETURN


'7100 DIM FullMonth$(12), CHD$(7)
'FOR i = 1 TO 12: READ FullMonth$(i): NEXT i
'DATA January,February,March,April,May,June,July,August,September
'DATA October,November,December
'FOR i = 1 TO 7: READ CHD$(i): NEXT i
'DATA Wednesday,Thursday,Friday,Saturday,Sunday,Monday,Tuesday
''FOR X = 1 TO 12: PRINT FullMonth$(X): NEXT X
''FOR X = 1 TO 7: PRINT CHD$(X): NEXT X
'RETURN


FUNCTION FNABP (Z)
    FNABP = CDBL(INT((SIN((V / Z - INT(V / Z)) * P#) + 1) * 13.5))
END FUNCTION
FUNCTION FNGBP (Z)
    FNGBP = 100 * SIN(V / Z * P#)
END FUNCTION
FUNCTION FNBBP ()
    FNBBP = V - 28 * INT(V / 28) + 1
END FUNCTION
FUNCTION FNCBP ()
    FNCBP = V - 23 * INT(V / 23) + 1
END FUNCTION
FUNCTION FNDBP
    FNDBP = V - 33 * INT(V / 33) + 1
END FUNCTION
SUB PlaceCursor
    curlin = CSRLIN: posline = POS(0) - 1
    LOCATE curlin, posline

END SUB



SUB DOBBP (MONIN, DAYIN, YEARIN)
    NUMBER$ = "0123456789"
    CPOS1 = POS(0)
    BIMONBP: IN$ = "": IN$ = INKEY$: IF IN$ = "" THEN GOTO BIMONBP
    IF IN$ = CHR$(8) THEN LOCATE , CPOS1: PRINT "  ";: LOCATE , CPOS1: MONIN$ = "": GOTO BIMONBP
    IF INSTR(NUMBER$, IN$) = 0 THEN GOTO BIMONBP
    IF VAL(IN$) >= 0 THEN PRINT IN$; ELSE GOTO BIMONBP
    MONIN$ = MONIN$ + IN$

    IF LEN(MONIN$) = 2 THEN GOTO BIMONBP2 ELSE GOTO BIMONBP
    BIMONBP2: PRINT "-";: CPOS2 = POS(0)
    IF ((VAL(MONIN$) < 1) + (VAL(MONIN$) > 12)) THEN MONIN$ = "": LOCATE CSRLIN, CPOS1: PRINT " ";: LOCATE , CPOS1: GOTO BIMONBP
    IF INSTR(NUMBER$, IN$) = 0 THEN GOTO BIMONBP
    '-------------------------------------------------------------------------------------------------------------
    BIDAYBP: CPOS2 = POS(0): IN$ = "": IN$ = INKEY$: IF IN$ = "" THEN GOTO BIDAYBP
    IF INSTR(NUMBER$, IN$) = 0 THEN GOTO BIDAYBP
    IF IN$ = CHR$(8) THEN LOCATE , CPOS2: PRINT "  ";: LOCATE , CPOS2: DAYIN$ = "": GOTO BIDAYBP
    IF VAL(IN$) >= 0 THEN PRINT IN$; ELSE GOTO BIDAYBP
    DAYIN$ = DAYIN$ + IN$

    IF LEN(DAYIN$) = 2 THEN GOTO BIDAYBP2 ELSE GOTO BIDAYBP
    BIDAYBP2: PRINT "-";
    IF ((VAL(DAYIN$) < 1) + (VAL(DAYIN$) > 31)) THEN MONIN$ = "": LOCATE , CPOS2: GOTO BIYEARBP
    IF INSTR(NUMBER$, IN$) = 0 THEN GOTO BIDAYBP
    '-------------------------------------------------------------------------------------------------------------
    BIYEARBP: CPOS3 = POS(0): IN$ = "": IN$ = INKEY$: IF IN$ = "" THEN GOTO BIYEARBP
    IF INSTR(NUMBER$, IN$) = 0 THEN GOTO BIYEARBP
    IF IN$ = CHR$(8) THEN LOCATE , CPOS3: PRINT "    ";: LOCATE , CPOS3: YEARIN$ = "": GOTO BIYEARBP
    IF VAL(IN$) >= 0 THEN PRINT IN$; ELSE GOTO BIYEARBP
    YEARIN$ = YEARIN$ + IN$

    IF LEN(YEARIN$) = 4 THEN GOTO FINISHBP ELSE GOTO BIYEARBP

    FINISHBP: '
    '-------------------------------------------------------------------------------------------------------------
    MONIN = VAL(MONIN$): DAYIN = VAL(DAYIN$): YEARIN = VAL(YEARIN$)

END SUB



SUB PickDayBP
    DDAY$ = "WedThuFriSatSunMonTue": ' Line 2110
    AY$ = MID$(DDAY$, B9 * 3 - 2, 3): ' Line 2120 and  RETURN

END SUB


FUNCTION CENTERBP
    CENTERBP = 31 - (INT((LEN(a1$) + LEN(b1$) + 18) / 2))
END FUNCTION


SUB PFSBP
    IF LEN("graphs\" + FileName$) = 0 THEN PRINT "Sorry, there is NO file to print": RETURN
    Path$ = "%SystemRoot%\system32\notepad.exe " + "graphs\" + FileName$: 'FileArray$(Choice%)
    SHELL _HIDE Path$

    ''    GF% = FREEFILE
    'OPEN "graphs\" + FileName$ FOR INPUT AS #6
    'LC = 0
    'WHILE NOT EOF(6)
    '    LINE INPUT #6, fline$
    '    LPRINT fline$
    '    LC = LC + 1
    '    IF LC = 34 THEN LPRINT CHR$(12)

    'WEND
    'CLOSE #6

END SUB

SUB PFCBP
    IF LEN("graphs\" + FileName$) = 0 THEN PRINT "Sorry, there is NO file to print": RETURN
    Path$ = "%SystemRoot%\system32\notepad.exe " + "graphs\" + FileName$: 'FileArray$(Choice%)
    SHELL _HIDE Path$

    ''GF% = FREEFILE
    'OPEN "graphs\" + FileName$ FOR INPUT AS #6

    'WHILE NOT EOF(6)
    '    LINE INPUT #6, fline$
    '    LPRINT fline$
    'WEND
    ''LPRINT CHR$(12)
    'CLOSE #6

END SUB

SUB CheckDirBP
    IF _DIREXISTS("graphs") = 0 THEN
        MKDIR "graphs"
    END IF
END SUB


FUNCTION FNABG (Z)
    FNABG = CDBL(INT((SIN((V / Z - INT(V / Z)) * P#) + 1) * 13.5))
END FUNCTION

FUNCTION FNGBG (Z)
    FNGBG = 100 * SIN(V / Z * P#)
END FUNCTION

FUNCTION FNBBG ()
    FNBBG = V - 28 * INT(V / 28) + 1
END FUNCTION

FUNCTION FNCBG ()
    FNCBG = V - 23 * INT(V / 23) + 1
END FUNCTION

FUNCTION FNDBG
    FNDBG = V - 33 * INT(V / 33) + 1
END FUNCTION



SUB DOBBG (MONIN, DAYIN, YEARIN)
    NUMBER$ = "0123456789"
    CPOS1 = POS(0)
    BGBIMON: IN$ = "": IN$ = INKEY$: IF IN$ = "" THEN GOTO BGBIMON
    IF IN$ = CHR$(8) THEN LOCATE , CPOS1: PRINT "  ";: LOCATE , CPOS1: MONIN$ = "": GOTO BGBIMON
    IF INSTR(NUMBER$, IN$) = 0 THEN GOTO BGBIMON
    IF VAL(IN$) >= 0 THEN PRINT IN$; ELSE GOTO BGBIMON
    MONIN$ = MONIN$ + IN$

    IF LEN(MONIN$) = 2 THEN GOTO BGBIMON2 ELSE GOTO BGBIMON
    BGBIMON2: PRINT "-";: CPOS2 = POS(0)
    IF ((VAL(MONIN$) < 1) + (VAL(MONIN$) > 12)) THEN MONIN$ = "": LOCATE CSRLIN, CPOS1: PRINT " ";: LOCATE , CPOS1: GOTO BGBIMON
    IF INSTR(NUMBER$, IN$) = 0 THEN GOTO BGBIMON
    '-------------------------------------------------------------------------------------------------------------
    BGBIDAY: CPOS2 = POS(0): IN$ = "": IN$ = INKEY$: IF IN$ = "" THEN GOTO BGBIDAY
    IF INSTR(NUMBER$, IN$) = 0 THEN GOTO BGBIDAY
    IF IN$ = CHR$(8) THEN LOCATE , CPOS2: PRINT "  ";: LOCATE , CPOS2: DAYIN$ = "": GOTO BGBIDAY
    IF VAL(IN$) >= 0 THEN PRINT IN$; ELSE GOTO BGBIDAY
    DAYIN$ = DAYIN$ + IN$

    IF LEN(DAYIN$) = 2 THEN GOTO BGBIDAY2 ELSE GOTO BGBIDAY
    BGBIDAY2: PRINT "-";
    IF ((VAL(DAYIN$) < 1) + (VAL(DAYIN$) > 31)) THEN MONIN$ = "": LOCATE , CPOS2: GOTO BGBIYEAR
    IF INSTR(NUMBER$, IN$) = 0 THEN GOTO BGBIDAY
    '-------------------------------------------------------------------------------------------------------------
    BGBIYEAR: CPOS3 = POS(0): IN$ = "": IN$ = INKEY$: IF IN$ = "" THEN GOTO BGBIYEAR
    IF INSTR(NUMBER$, IN$) = 0 THEN GOTO BGBIYEAR
    IF IN$ = CHR$(8) THEN LOCATE , CPOS3: PRINT "    ";: LOCATE , CPOS3: YEARIN$ = "": GOTO BGBIYEAR
    IF VAL(IN$) >= 0 THEN PRINT IN$; ELSE GOTO BGBIYEAR
    YEARIN$ = YEARIN$ + IN$

    IF LEN(YEARIN$) = 4 THEN GOTO BGFINISH ELSE GOTO BGBIYEAR

    BGFINISH: '
    '-------------------------------------------------------------------------------------------------------------
    MONIN = VAL(MONIN$): DAYIN = VAL(DAYIN$): YEARIN = VAL(YEARIN$)

END SUB











SUB BMAnother
    BEEP: LOCATE 39, 1: PRINT SPC(79);: LOCATE 43, 16
    LOCATE 41, 1: ' PRINT SPC(79);
    LOCATE 43, 28: COLOR 15
    in$ = "": PRINT "Another? (Y/N)";
    doitagain: DO: SLEEP

        in$ = UCASE$(INKEY$)
        IF in$ = "Y" THEN EXIT DO
        IF UCASE$(in$) = "N" THEN EXIT DO
        in$ = ""
    LOOP
    IF in$ = "N" THEN
        IF _FILEEXISTS("graphs\filedata.dat") THEN KILL "graphs\filedata.dat": Continue$ = "bioprint": CLOSE: RUN
    END IF
    IF in$ = "Y" THEN LOCATE 42, 1: PRINT SPC(79);: LOCATE 43, 1: PRINT SPC(79);: ELSE in$ = ""
    IF in$ = "" THEN GOTO doitagain
END SUB



SUB BEInactive
    MESSAGE$ = "REMOVING INACTIVE DATA"
    CALL BEcenterbar(MESSAGE$)
    OPEN "O", 7, "FileList.Dat"
    F% = FREEFILE
    OPEN "R", F%, "BIO.DAT", 60: l1! = LOF(F%) / 60
    FIELD F%, 30 AS N1$, 10 AS Date1$, 10 AS Date2$, 6 AS ge$, 1 AS Active$

    FOR xyxy = 2 TO l1!
        GET F%, xyxy
        IF Active$ = "I" THEN
            LSET N1$ = "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
            LSET Date1$ = "%%%%%%%%%%"
            LSET Date2$ = "%%%%%%%%%%"
            LSET ge$ = "%%%%%%"
            LSET Active$ = "%"
            LSET Nil$ = "%%%"
            PUT F%, xyxy
        END IF

    NEXT xyxy
    SOUND 1175, 1: SOUND 1318, 1: SOUND 1175, 1
    CLOSE F%
    SOUND 1175, 1: SOUND 1318, 1: SOUND 1175, 1
    CLOSE F%
END SUB


SUB BEmenu STATIC
    Black = 0: Blue = 1: Green = 2: Cyan = 3: Red = 4: Magenta = 5: Brown = 6: Normal = 7: Gray = 8: LBlue = 9: LGreen = 10: LCyan = 11: LRed = 12: LMagenta = 13: Yellow = 14: White = 15: Blink = 16
    ms = White
    COLOR LGreen, 1
    LOCATE 14, 1: FOR spaceit = 1 TO 12: PRINT STRING$(80, 32);: NEXT spaceit 'COLOR Yellow
    '   LOCATE 15, 32: COLOR LGreen + 16, 1: PRINT "*** M E N U ***": COLOR LGreen
    LOCATE 18, 10: PRINT "<";: COLOR ms: PRINT "S";: COLOR LGreen: PRINT ">earch                          * <";: COLOR ms: PRINT "E";: COLOR LGreen: PRINT ">dit"
    LOCATE 19, 10: PRINT "<";: COLOR ms: PRINT "P";: COLOR LGreen: PRINT ">rint a file list                 <";: COLOR LRed: PRINT "R";: COLOR LGreen: PRINT ">epair DATE format ";: COLOR LGreen: 'COLOR LRed: PRINT "(use caution)": COLOR LGreen
    LOCATE 20, 10: PRINT "<";: COLOR ms: PRINT "I";: COLOR LGreen: PRINT "> Remove all ";: COLOR White: PRINT "I";: COLOR LGreen: PRINT "nactive records     <";: COLOR ms: PRINT "ESC";: COLOR LGreen: PRINT "> to Exit"
    LOCATE 24, 24: PRINT "* (you must know the record Number)";

END SUB



SUB BEcenterbar (message$) STATIC
    COLOR , 0
    position = 40 - LEN(message$) / 2
    DoubleLine$ = STRING$(80, 205)
    LOCATE 11, 1: PRINT DoubleLine$;
    LOCATE 12, 1: PRINT "                                                                                ";
    LOCATE 12, position: PRINT message$;
    LOCATE 13, 1: PRINT DoubleLine$;

END SUB
SUB waitforit STATIC
    AnyKey$ = INPUT$(1): AnyKey$ = ""
END SUB

SUB BEPrintToFile
    '                                                                                PRINT LIST TO FILE ROUTINE
    OPEN "O", 7, "FileList.Dat"
    F% = FREEFILE
    OPEN "R", F%, "BIO.DAT", 60: l1! = LOF(F%) / 60
    FIELD F%, 30 AS N1$, 10 AS Date1$, 10 AS Date2$, 6 AS ge$, 1 AS Active$


    FOR xyxy = 2 TO l1!
        GET F%, xyxy
        IF N1$ <> STRING$(30, "%") THEN
            poline$ = "######                                                                         "
            Header$ = "Record #                        DOB:      Filed on:   Gender:   Active:     Nul"
            MID$(poline$, 10, 30) = N1$
            MID$(poline$, 32, 10) = Date1$
            MID$(poline$, 43, 10) = Date2$
            MID$(poline$, 56, 6) = ge$
            MID$(poline$, 68, 1) = Active$

            PRINT #7, USING poline$; xyxy
        END IF
    NEXT xyxy
    SOUND 1175, 1: SOUND 1318, 1: SOUND 1175, 1
    CLOSE #7
    CLOSE F%
    Path$ = "%SystemRoot%\system32\notepad.exe filelist.dat"
    SHELL _HIDE Path$


END SUB


SUB BEdatefixer
    MESSAGE$ = "MAKING THE DATES CONSISTENT"
    CALL BEcenterbar(MESSAGE$)

    F% = FREEFILE
    OPEN "R", F%, "BIO.DAT", 60: l1! = LOF(F%) / 60
    FIELD F%, 30 AS Name1$, 10 AS Date1$, 10 AS Date2$, 6 AS Gender$, 1 AS Active$, 3 AS Nil$
    FOR xyxy = 2 TO l1!
        GET F%, xyxy
        one% = 1: three% = 3: six% = 6

        IF MID$(Date1$, 1, 1) <> "%" THEN

            TempDate1$ = Date1$
            TempDate2$ = Date2$
            MID$(TempDate1$, three%, one%) = "-": MID$(TempDate1$, six%, one%) = "-"
            MID$(TempDate2$, three%, one%) = "-": MID$(TempDate2$, six%, one%) = "-"

            LSET Date1$ = TempDate1$
            LSET Date2$ = TempDate2$
            PUT #F%, xyxy
        END IF
    NEXT xyxy
    SOUND 1175, 1: SOUND 1318, 1: SOUND 1175, 1
    SOUND 1175, 1: SOUND 1318, 1: SOUND 1175, 1
    CLOSE F%

END SUB

SUB BEkeyboardentries (entry$, cursorline, cursorpos)
    '------------------------------------ NUMERIC KEYBOARD INPUTS START --------------------------------------
    LOCATE cursorline, cursorpos: PRINT "";
    '    LOCATE 10, 10: PRINT "Enter a number value: ";
    DO: SLEEP
        K$ = INKEY$
        IF K$ >= (CHR$(45)) + (CHR$(47)) + (CHR$(48)) AND K$ <= CHR$(57) THEN entry$ = entry$ + K$ ' numbers only
        L = LEN(entry$) ' check entry length for possible backspace
        IF K$ = CHR$(45) AND flag = 0 THEN entry$ = entry$ + K$: flag = 0: mark = L ' decimal point
        IF K$ = CHR$(8) AND L > 0 THEN ' backspace pressed and entry has a length
            entry$ = MID$(entry$, 1, L - 1) ' remove one character from entry$
            IF LEN(entry$) < mark THEN flag = 0 ' allow decimal point entry if other was removed.
            LOCATE CSRLIN, POS(0) - 1: PRINT SPACE$(1); ' remove end character from screen
        END IF
        LOCATE cursorline, cursorpos: PRINT entry$; ' display entry to user (semicolon required for correct POS) 10 & 32
        IF L = 11 THEN EXIT DO
    LOOP UNTIL K$ = CHR$(13): ' AND L > 0 'assures something is entered
    IF LEN(entry$) = 11 THEN entry$ = LEFT$(entry$, 10)
    'LOCATE 20, 1: PRINT entry$: PRINT LEN(entry$)
    '------------------------------------ NUMERIC KEYBOARD INPUTS FINISH -------------------------------------

END SUB


